SystemOrganization addCategory: #'Subjectopia-Core'!
SystemOrganization addCategory: #'Subjectopia-ForceTree'!
SystemOrganization addCategory: #'Subjectopia-ForceTree-Tests'!
SystemOrganization addCategory: #'Subjectopia-MailSending'!
SystemOrganization addCategory: #'Subjectopia-Perspective'!
SystemOrganization addCategory: #'Subjectopia-Perspective-Tests'!
SystemOrganization addCategory: #'Subjectopia-BankAccount'!
SystemOrganization addCategory: #'Subjectopia-Core-Tests'!
SystemOrganization addCategory: #'Subjectopia-Group Programming'!
SystemOrganization addCategory: #'Subjectopia-Private Variable'!
SystemOrganization addCategory: #'Subjectopia-Role'!
SystemOrganization addCategory: #'Subjectopia-Role-Tests'!
SystemOrganization addCategory: #'Subjectopia-Moose-FAMIXClass'!
SystemOrganization addCategory: #'Subjectopia-Moose'!
SystemOrganization addCategory: #'Subjectopia-Moose-Tests'!
SystemOrganization addCategory: #'Subjectopia-Moose-Setup'!

MooseGroup subclass: #SubjectiveMooseGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Moose'!

!SubjectiveMooseGroup class methodsFor: 'changed methods' stamp: 'DanielLangone 10/26/2010 10:30'!
withAll: collection 
	| wantedClass |
	^ (self withKnownType: MooseGroup withAll: collection)! !

!SubjectiveMooseGroup methodsFor: 'changed methods' stamp: 'DanielLangone 10/28/2010 16:35'!
changeTypeToDefaultType
	self decisionMetaObject: (DecisionMetaObject new).! !

!SubjectiveMooseGroup methodsFor: 'changed methods' stamp: 'DanielLangone 10/28/2010 11:15'!
initialize: capacity 
	 
	self initialize. 
	self description: 'Group'.
	self decisionMetaObject: (DecisionMetaObject new).
	self updateTypeAccordingToEntities.! !

!SubjectiveMooseGroup methodsFor: 'changed methods' stamp: 'DanielLangone 10/28/2010 11:41'!
initializeWithAll: aCollection
	self entityStorage addAll: aCollection.
	self updateTypeAccordingToEntities.! !

!SubjectiveMooseGroup methodsFor: 'changed methods' stamp: 'DanielLangone 10/28/2010 16:35'!
updateTypeAccordingToEntities
	| common wantedType class |
	common := self commonMetaDescription.
	wantedType := (common name, 'DecisionMetaObject') asSymbol.
	
	decisionMetaObject class name = wantedType ifTrue: [^ self ].
	class := DecisionMetaObject allSubclasses 
		detect: [ :each | each name == wantedType ]
		ifNone: [ ^ self changeTypeToDefaultType ].
	self decisionMetaObject: (class new).
! !

MooseAbstractGroup subclass: #SubjectiveMooseAbstractGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Moose'!

!SubjectiveMooseAbstractGroup methodsFor: 'changed methods' stamp: 'DanielLangone 10/26/2010 10:07'!
allWithType: aMetaDesription ofGroupClass: aSmalltalkClass
	^ self privateState cacheAt: aMetaDesription name
		ifAbsentPut: [
			MooseGroup 
				withAll: (self entityStorage selectAllWithType: aMetaDesription)
				withDescription: 'All ' , aMetaDesription name asLowercase asEnglishPlural]! !

!SubjectiveMooseAbstractGroup methodsFor: 'changed methods' stamp: 'DanielLangone 11/5/2010 11:13'!
computeDuplication 
	<menuItem: 'Compute Subjective duplication' category: 'Utilities'>
	| detector chains | 
	detector := DudeDetector 
		new: DudeJavaFiles 
		from: self entities 
		andObserver: DudeObserver defaultObserverForTextPreprocessing 
		inModel: self mooseModel. 
	detector observer: DudeObserver defaultObserverForDupDetecting. 
	chains := detector getMultiplicationsWith1032. 
	Transcript show: chains size printString , 'chains found!!'.
	AlertDialogWindow new message: 'Computation of Duplication finished'.! !

MooseGroupTest subclass: #TestSubjectiveFamixModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Moose-Tests'!

!TestSubjectiveFamixModel methodsFor: 'testing' stamp: 'DanielLangone 2/10/2011 13:50'!
testGroupType
	| group numberOfClasses numberOfMethods changing|
	changing := Subjectopia isSubjective.
	"Turn on subjectivity if needed"
	changing ifFalse: [Subjectopia start. changing := true].
	self assert: (Subjectopia isSubjective).
	group := MooseGroup new.
	
	self assert: (group class = MooseGroup).
	[group viewSystemComplexity. self assert: false.] on: Error do: [self assert: true].
	self assert: (group class = MooseGroup).
	
	group addAll: self model allClasses.
	self assert: (group class = MooseGroup).
	[group viewSystemComplexity. self assert: true.] on: Error do: [self assert: false].
	self assert: (group class = MooseGroup).
	
	group addAll: self model allMethods.
	self assert: (group class = MooseGroup).
	[group viewSystemComplexity. self assert: false.] on: Error do: [self assert: true].
	self assert: (group class = MooseGroup).
	
	group removeAll: self model allMethods.
	self assert: (group class = MooseGroup).
	[group viewSystemComplexity. self assert: true.] on: Error do: [self assert: false].
	self assert: (group class = MooseGroup).
	
	group add: self model allMethods first.
	self assert: (group class = MooseGroup).
	[group viewSystemComplexity. self assert: false.] on: Error do: [self assert: true].
	self assert: (group class = MooseGroup).
	
	group remove: self model allMethods first.
	self assert: (group class = MooseGroup).
	[group viewSystemComplexity. self assert: true.] on: Error do: [self assert: false].
	self assert: (group class = MooseGroup).
	
	changing ifTrue: [Subjectopia stop].! !

TestCase subclass: #CodeSystemPerspectiveTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Group Programming'!

!CodeSystemPerspectiveTest methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 15:18'!
testOneProgrammerAddAndDeleteLine
	| programmer code somecode |
	"Programmer is a Perspective"
	programmer := Programmer new.
	
	"Empty SourceCode"
	code := SourceCode new.
	code decisionMetaObject: (SourceCodePerspectives new).
	
	"Manipulating code"
	code deleteLineAt: 1 through: programmer.	 "Should not affect the code!!"
	code addLine: 'test' at: 1 through: programmer. 
	code deleteLineAt: 1 through: programmer.
	
	"Looking at code without perspective"
	self assert: ((code asOrderedCollection size) = 0).
	self assert:((code asText) = '').
	
	"Looking at code from perspective of programmer"
	self assert: (((code codeThrough: programmer) asOrderedCollection size) = 0).
	self assert:(((code codeThrough: programmer) asText) = '').
	
	"Looking at code without perspective"
	self assert: ((code asOrderedCollection size) = 0).
	self assert:((code asText) = '').
	
	"Manipulating code second time. At the end looks like from programmer:
	test5
	test"
	code addLine: 'test' at: 1 through: programmer. 
	code addLine: 'test' at: 2 through: programmer. 
	code addLine: 'test2' at: 1 through: programmer. 
	code addLine: 'test' at: 3 through: programmer. 
	code deleteLineAt: 3 through: programmer.
	code addLine: 'test5' at: 1 through: programmer. 
	code addLine: 'test' at: 3 through: programmer. 
	code deleteLineAt: 3 through: programmer.
	
	
	"Looking at code without perspective"
	self assert: ((code asOrderedCollection size) = 0).
	self assert:((code asText) = '').
	
	"Looking at code from perspective of programmer"
	self assert: (((code codeThrough: programmer) asOrderedCollection size) = 2).
	self assert: (((code codeThrough: programmer) asOrderedCollection at: 1) = 'test5').
	self assert: (((code codeThrough: programmer) asOrderedCollection at: 2) = 'test').
	
	"Looking at code without perspective"
	self assert: ((code asOrderedCollection size) = 0).
	self assert:((code asText) = '').
	! !

!CodeSystemPerspectiveTest methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 15:04'!
testOneProgrammerAddLine
	| programmer code |
	"Programmer is a Perspective"
	programmer := Programmer new.
	
	"SourceCode is a subject, which behaves differently through which perspective you look"
	code := SourceCode new.
	code decisionMetaObject: (SourceCodePerspectives new).
	
	"You should never directly manipulate the code, but always through a perspective"
	[code addLine: 'test2' at: 1. self assert: false] on: Error do: [self assert: true].
	self assert: ((code asOrderedCollection size) = 0).
	self assert:((code asText) = '').
	
	"Adding line test at line 1 through the perspective of the programmer to the code"
	code addLine: 'test' at: 1 through: programmer.
	
	"Looking at code without perspective"
	self assert: ((code asOrderedCollection size) = 0).
	self assert:((code asText) = '').
	
	"Looking at code through perspective of programmer"
	self assert: (((code codeThrough: programmer) asOrderedCollection size) = 1).
	self assert: (((code codeThrough: programmer) asOrderedCollection at: 1) = 'test').
	self assert: (((code codeThrough: programmer) asText) = 'test').
	
	"Looking at code without perspective"
	self assert: ((code asOrderedCollection size) = 0).
	self assert:((code asText) = '').
	
	"You can though add an Code as OrderedCollection to the sourcecode. Now
	First line contains testing"
	code code: (OrderedCollection new add: 'testing'; yourself).
	
	self assert: ((code asOrderedCollection size) = 1).
	self assert: ((code asOrderedCollection at:1) = 'testing').
	self assert:((code asText) = 'testing').
	
	self assert: (((code codeThrough: programmer) asOrderedCollection size) = 1).
	self assert: (((code codeThrough: programmer) asOrderedCollection at: 1) = 'test').
	self assert: (((code codeThrough: programmer) asText) = 'test').
	
	self assert: ((code asOrderedCollection size) = 1).
	self assert: ((code asOrderedCollection at:1) = 'testing').
	self assert:((code asText) = 'testing').
	
	"Adding line test2 at line 2 through the perspective of the programmer to the code"
	code addLine: 'test2' at: 2 through: programmer.
	
	self assert: ((code asOrderedCollection size) = 1).
	self assert: ((code asOrderedCollection at:1) = 'testing').
	self assert:((code asText) = 'testing').
	
	self assert: (((code codeThrough: programmer) asOrderedCollection size) = 2).
	self assert: (((code codeThrough: programmer) asOrderedCollection at: 1) = 'test').
	self assert: (((code codeThrough: programmer) asOrderedCollection at: 2) = 'test2').

	self assert: ((code asOrderedCollection size) = 1).
	self assert: ((code asOrderedCollection at:1) = 'testing').
	self assert:((code asText) = 'testing').
	
	"Changing line 2 to test3 through the perspective of the programmer to the code"
	code addLine: 'test3' at: 2 through: programmer.
	
	self assert: ((code asOrderedCollection size) = 1).
	self assert: ((code asOrderedCollection at:1) = 'testing').
	self assert:((code asText) = 'testing').
	
	self assert: (((code codeThrough: programmer) asOrderedCollection size) = 2).
	self assert: (((code codeThrough: programmer) asOrderedCollection at: 1) = 'test').
	self assert: (((code codeThrough: programmer) asOrderedCollection at: 2) = 'test3').

	self assert: ((code asOrderedCollection size) = 1).
	self assert: ((code asOrderedCollection at:1) = 'testing').
	self assert:((code asText) = 'testing').! !

!CodeSystemPerspectiveTest methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 14:58'!
testOneProgrammerDeleteLine
	| programmer code somecode |
	"Programmer is a Perspective"
	programmer := Programmer new.
	
	"SourceCode is a subject, which behaves differently through which perspective you look"
	code := SourceCode new code: (OrderedCollection new add: 'test'; yourself).
	code decisionMetaObject: (SourceCodePerspectives new).
	
	"You should never directly manipulate the code, but always through a perspective"
	[code deleteLineAt: 1. self assert: false] on: Error do: [self assert: true].
	self assert: ((code asOrderedCollection size) = 1).
	self assert: ((code asOrderedCollection at:1) = 'test').
	self assert:((code asText) = 'test').
	
	"Adding line test at line 1 through the perspective of the programmer to the code"
	code deleteLineAt: 1 through: programmer.
	
	"Looking at code without perspective"
	self assert: ((code asOrderedCollection size) = 1).
	self assert: ((code asOrderedCollection at:1) = 'test').
	self assert:((code asText) = 'test').
	
	"Looking at code through perspective of programmer"
	self assert: (((code codeThrough: programmer) asOrderedCollection size) = 0).
	self assert: (((code codeThrough: programmer) asText) = '').
	
	"Looking at code without perspective"
	self assert: ((code asOrderedCollection size) = 1).
	self assert: ((code asOrderedCollection at:1) = 'test').
	self assert:((code asText) = 'test').
	
	"You can though add an Code as OrderedCollection to the sourcecode. Now
	First line contains testing"
	code code: (OrderedCollection new add: 'test'; yourself; add: 'testing'; yourself).
	
	self assert: ((code asOrderedCollection size) = 2).
	self assert: ((code asOrderedCollection at:1) = 'test').
	self assert: ((code asOrderedCollection at:2) = 'testing').
	
	somecode := (code codeThrough: programmer).
	self assert: (((code codeThrough: programmer) asOrderedCollection size) = 1).
	self assert: (((code codeThrough: programmer) asOrderedCollection at: 1) = 'testing').
	self assert: (((code codeThrough: programmer) asText) = 'testing').
	
	self assert: ((code asOrderedCollection size) = 2).
	self assert: ((code asOrderedCollection at:1) = 'test').
	self assert: ((code asOrderedCollection at:2) = 'testing').! !

!CodeSystemPerspectiveTest methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 15:47'!
testTwoProgrammerAddAndDeleteLine
	| programmerOne programmerTwo programmerMerge code somecode samplecode |
	"Programmer is a Perspective"
	programmerOne := Programmer new.
	programmerTwo := Programmer new.
	
	"Empty SourceCode"
	code := SourceCode new.
	code decisionMetaObject: (SourceCodePerspectives new).
	
	"Manipulating code"
	code addLine: 'test' at: 1 through: programmerOne. 
	code addLine: 'test2' at: 2 through: programmerOne. 
	code addLine: 'test3' at: 3 through: programmerTwo. 
	code deleteLineAt: 2 through: programmerOne. 
	code addLine: 'test4' at: 4 through: programmerOne. 
	code addLine: 'test5' at: 3 through: programmerTwo. 
	code addLine: 'test6' at: 5 through: programmerOne. 
	code addLine: 'test7' at: 2 through: programmerTwo. 
	code addLine: 'test8' at: 4 through: programmerOne. 
	
	"View code without perspective"
	self assert: ((code asOrderedCollection size) = 0).
	self assert: ((code asText) = '').
	
	"View code from perspective of ProgrammerOne"
	self assert: (((code codeThrough: programmerOne) asOrderedCollection size) = 5).
	self assert: (((code codeThrough: programmerOne) asOrderedCollection at:1) = 'test').
	self assert: (((code codeThrough: programmerOne) asOrderedCollection at:2) = nil).
	self assert: (((code codeThrough: programmerOne) asOrderedCollection at:3) = nil).
	self assert: (((code codeThrough: programmerOne) asOrderedCollection at:4) = 'test8').
	self assert: (((code codeThrough: programmerOne) asOrderedCollection at:5) = 'test6').
	
	"View code from perspective of ProgrammerTwo"
	self assert: (((code codeThrough: programmerTwo) asOrderedCollection size) = 3).
	self assert: (((code codeThrough: programmerTwo) asOrderedCollection at:1) = nil).
	self assert: (((code codeThrough: programmerTwo) asOrderedCollection at:2) = 'test7').
	self assert: (((code codeThrough: programmerTwo) asOrderedCollection at:3) = 'test5').
	
	"View first changes of ProgrammerOne and then programmerTwo, just to play arround..."
	programmerMerge := programmerOne childAtBegin: (programmerTwo child).
	samplecode := (code codeThrough: programmerMerge) .
	self assert: (((code codeThrough: programmerMerge) asOrderedCollection size) = 5).
	self assert: (((code codeThrough: programmerMerge) asOrderedCollection at:1) = 'test').
	self assert: (((code codeThrough: programmerMerge) asOrderedCollection at:2) = 'test7').
	self assert: (((code codeThrough: programmerMerge) asOrderedCollection at:3) = nil).
	self assert: (((code codeThrough: programmerMerge) asOrderedCollection at:4) = 'test8').
	self assert: (((code codeThrough: programmerMerge) asOrderedCollection at:5) = 'test6').! !

TestCase subclass: #ForceTreeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree-Tests'!

!ForceTreeTest methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 16:07'!
testAquintanceDeterminant
	|subject dummy dummy2 |
	
	dummy := MockObject new.
	dummy2 := MockObject new.
	subject := MockForceTreeSubject new.
	subject decisionMetaObject: (MockForceTree new).
	
	dummy2 id: 10.
	dummy id: 5.
	dummy myValue: 10.
	self assert: ((subject acquintanceDeterminantWithIdentity: 5) =1). "Depends on dummy and not dummy2"
	
	dummy myValue: 11.
	dummy2 myValue: 1.
	self assert: ((subject acquintanceDeterminantWithIdentity: 5) =2). "Depends on dummy and not dummy2"! !

!ForceTreeTest methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:52'!
testArgumentDeterminantArgumentDeterminant
	| subject |
	subject := MockForceTreeSubject new.
	subject decisionMetaObject: (MockForceTree new).
	
	self assert: ((subject argumentArgumentDeterminant: 2)= 1).
	
	self assert: ((subject argumentArgumentDeterminant: 3)= 2).
	
	self assert: ((subject argumentArgumentDeterminant: 5)= 3).! !

!ForceTreeTest methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:52'!
testArgumentDeterminantNotRoot
	| subject dummy |
	dummy := MockObject new.
	subject := MockForceTreeSubject new.
	subject decisionMetaObject: (MockForceTree new).
	
	dummy myValue: 1.
	self assert: ((dummy argumentNotRootOfTree: subject withArg: 5)= 1).
	
	dummy myValue: 1.
	self assert: ((dummy argumentNotRootOfTree: subject withArg: 1)= 2).
	
	dummy myValue: 6.
	self assert: ((dummy argumentNotRootOfTree: subject withArg: 5)= 3).! !

!ForceTreeTest methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:52'!
testArgumentsDeterminant
	| subject  |
	subject := MockForceTreeSubject new.
	subject decisionMetaObject: (MockForceTree new).
	self assert: ((subject argumentsDeterminant: 1) = 3).
	self assert: ((subject argumentsDeterminant: 5) = 6).
	! !

!ForceTreeTest methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:52'!
testComplexForceTree
	| subject dummy |
	dummy := MockObject new.
	subject := MockForceTreeSubject new.
	subject decisionMetaObject: (MockForceTree new).
	
	subject someValue: 10.
	self assert: ((dummy complexFor: subject withArg: 3)= 5).
	
	subject someValue: 10.
	dummy myValue: 5.
	self assert: ((dummy complexFor: subject withArg: 3)= 4).
	
	subject someValue: 3.
	self assert: ((dummy complexFor: subject withArg: 3)= 3).
	
	subject someValue: 1.
	self assert: ((dummy complexFor: subject withArg: 5)= 1).
	
	subject someValue: 1.
	self assert: ((dummy complexFor: subject withArg: 1)= 2).! !

!ForceTreeTest methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:52'!
testMethodDeterminant
	| subject |
	subject := MockForceTreeSubject new.
	subject decisionMetaObject: (MockForceTree new).
	self assert: (subject methodDeterminant = 1).
	self assert: ((subject methodDeterminant: 2) = 3).! !

!ForceTreeTest methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:52'!
testReceiverDeterminant
	| subject |
	subject := MockForceTreeSubject new.
	subject decisionMetaObject: (MockForceTree new).
	subject someValue: 5.
	self assert: (subject receiverDeterminantNoArguments = 1).
	subject someValue: 3.
	self assert: (subject receiverDeterminantNoArguments = 2).
	! !

!ForceTreeTest methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:53'!
testReceiverDeterminantNotRoot
	| subject dummy |
	dummy := MockObject new.
	subject := MockForceTreeSubject new.
	subject decisionMetaObject: (MockForceTree new).
	
	dummy myValue: 1.
	subject someValue: 5.
	self assert: ((dummy receiverNotRootOfTree: subject)= 1).
	
	subject someValue: 6.
	self assert: ((dummy receiverNotRootOfTree: subject)= 2).
	
	dummy myValue: 10.
	self assert: ((dummy receiverNotRootOfTree: subject)= 3).
	
	subject someValue: 5.
	self assert: ((dummy receiverNotRootOfTreeToo: subject withArg: 1)= 1).
	
	subject someValue: 1.
	self assert: ((dummy receiverNotRootOfTreeToo: subject withArg: 1)= 2).
	
	self assert: ((dummy receiverNotRootOfTreeToo: subject withArg: 6)= 3).
	! !

!ForceTreeTest methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:53'!
testSenderDeterminant
	| subject dummy |
	dummy := MockObject new.
	subject := MockForceTreeSubject new.
	subject decisionMetaObject: (MockForceTree new).
	dummy myValue: 5.
	self assert: ((dummy senderDeterminant: subject)= 1).
	dummy myValue: 3.
	self assert: ((dummy senderDeterminant: subject) = 2).
	! !

!ForceTreeTest methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:53'!
testSenderDeterminantNotRoot
	| subject dummy |
	dummy := MockObject new.
	subject := MockForceTreeSubject new.
	subject decisionMetaObject: (MockForceTree new).
	
	dummy myValue: 5.
	self assert: ((dummy senderNotRootOfTree: subject withArg: 1)= 1).
	
	dummy myValue: 1.
	self assert: ((dummy senderNotRootOfTree: subject withArg: 1)= 2).
	
	self assert: ((dummy senderNotRootOfTree: subject withArg: 6)= 3).! !

!ForceTreeTest methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:53'!
testSenderDeterminantSenderDeterminant
	| subject dummy |
	dummy := MockObject new.
	subject := MockForceTreeSubject new.
	subject decisionMetaObject: (MockForceTree new).
	
	dummy myValue: 2.
	self assert: ((dummy senderSenderDeterminant: subject)= 1).
	
	dummy myValue: 3.
	self assert: ((dummy senderSenderDeterminant: subject)= 2).
	
	dummy myValue: 5.
	self assert: ((dummy senderSenderDeterminant: subject)= 3).! !

TestCase subclass: #PerspectiveTest
	instanceVariableNames: 'decisionMetaObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Perspective-Tests'!

!PerspectiveTest methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 09:52'!
testInstanceVariableLayer
	| aSubject instVarAccessLayer instVarModificationLayer |
	instVarAccessLayer := (InstanceVariableLayerAccess new instanceVariableName: #someVariable).
	instVarModificationLayer := (InstanceVariableLayerModification new instanceVariableName: #someVariable).
	
	aSubject := PerspectiveSubject new.
	aSubject decisionMetaObject: (DecisionMetaObject new register: (Perspective new) for: #someVariable; register: (Perspective new) for: (#someVariable:)).
	
	
	self assert: ((aSubject someVariablethrough: (instVarAccessLayer)) = 5). 
	[aSubject someVariable: 15 through: instVarModificationLayer. self assert: true] on: Error do: [self assert: false.]. 
	self assert: ((aSubject someVariableThrough: instVarAccessLayer) = 15). ! !

!PerspectiveTest methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 09:55'!
testPerspectives
	| aSubject |
	aSubject := PerspectiveSubject new.
	aSubject decisionMetaObject: (DecisionMetaObject new register: (Perspective new) for: #test).
	
	self assert: ((aSubject test) = 2). "Normal message call to subject. Default behavior"
	
	self assert: ((aSubject testthrough: (PerspectiveLayer new)) = 2). "Through empty perspective"
	self assert: ((aSubject testthrough: (MockLayer new child: (PerspectiveLayer new))) = 1). "Through empty perspective with two layers, first not implementing and second implementing the desired method"
	self assert: ((aSubject testthrough: (PerspectiveLayer new child: (MockLayer new))) = 1). "Through empty perspective with one layer implementing the desired method"
	! !

TestCase subclass: #PrivateVariableForceTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Private Variable'!

!PrivateVariableForceTree methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 09:27'!
testAccessAndManipulation
	|subject|
	"you can only access and change the instance variable if you are of Type PrivateSubject"
	subject := PrivateSubject new.
	subject decisionMetaObject: (PrivateForceTree new).
	
	
	[subject privateVariable. self assert: false] on: Error do: [self assert: true].
	self assert: ((subject accessPrivateVariableOf: subject) = 1).
	
	[subject privateVariable: 3. self assert: false] on: Error do: [self assert: true].
	
	[subject changePrivateVariableOf: subject to: 3. self assert: true] on: Error do: [self assert: false].
	
	[subject privateVariable. self assert: false] on: Error do: [self assert: true].
	self assert: ((subject accessPrivateVariableOf: subject) = 3).! !

TestCase subclass: #PrivateVariablePerspective
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Private Variable'!

!PrivateVariablePerspective methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 15:51'!
testAccessAndManipulation
	|subject|
	"you can only access and change the instance variable if you are of Type PrivateSubject"
	subject := PrivateSubject new.
	subject decisionMetaObject: (PrivatePerspective new).
	
	[subject privateVariable. self assert: false] on: Error do: [self assert: true].
	self assert: ((subject privateVariablethrough: (PrivateAccessLayer new)) = 1).
	
	[subject privateVariable: 3. self assert: false] on: Error do: [self assert: true].
	
	[subject privateVariable: 3 through: (PrivateModificationLayer new). self assert: true] on: Error do: [self assert: false].
	
	[subject privateVariable. self assert: false] on: Error do: [self assert: true].
	self assert: ((subject privateVariablethrough: (PrivateAccessLayer new)) = 3).! !

TestCase subclass: #PrivateVariableRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Private Variable'!

!PrivateVariableRole methodsFor: 'testing' stamp: 'DanielLangone 10/19/2010 09:16'!
testAccessAndManipulation
	|subject|
	"you can only access and change the instance variable if you are of Type PrivateSubject"
	subject := PrivateSubject new.
	subject decisionMetaObject: (PrivateRoleDictionary new generateDecisionMetaObject).
	
	[subject privateVariable. self assert: false] on: Error do: [self assert: true].
	self assert: ((subject privateVariablethrough: #private) = 1).
	
	[subject privateVariable: 3. self assert: false] on: Error do: [self assert: true].
	
	[subject privateVariable: 3 through: #private. self assert: true] on: Error do: [self assert: false].
	
	[subject privateVariable. self assert: false] on: Error do: [self assert: true].
	self assert: ((subject privateVariablethrough: #private) = 3).! !

TestCase subclass: #RolesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Role-Tests'!

!RolesTest methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 17:09'!
testRoles
	| aSubject roleR1 roleDictionary roleR2 |
	aSubject := RoleSubject new.
	
	"Building up role dictionary"
	roleDictionary := RoleDictionary new.
	roleR1 := MockRole new.
	roleR2 := (Role new) child: roleR1.
	roleDictionary register: roleR1 for: #r1.
	roleDictionary register: roleR2 for: #r2.
	
	"Building decisionMetaobject
	decisionMetaObject := DecisionMetaObject new.
	decisionMetaObject register: roleDictionary for: #test.
	decisionMetaObject register: roleDictionary for: #test2.
	decisionMetaObject register: roleDictionary for: #test3."
	 
	"Adding decision meta object to subject"
	aSubject decisionMetaObject: (roleDictionary generateDecisionMetaObject).
	
	self assert: ((aSubject test) = 1). "Normal message call to subject. Default behavior"
	self assert: ((aSubject test3) = 4). "Normal message call to subject. Default behavior"
	[aSubject test2. self assert: false] on: Error  do: [self assert: true]. "No definition for message test3"

	self assert: ((aSubject testthrough: #r1) = 2). "Through Role r1. Changed behavior of test"
	self assert: ((aSubject test2through: #r1) = 3). "Through Role r1. Added behavior for message test2"
	[aSubject test3through: #r1. self assert: false] on: Error do: [self assert: true]. "Through Role r1. Hide behavior for message test3"
	
	self assert: ((aSubject testthrough: #r2) = 2). "r2 has r1 as a child. thus same behavior as with r1 expected"
	self assert: ((aSubject test2through: #r2) = 3). 

	[aSubject test3through: #r2. self assert: false] on: Error do: [self assert: true].! !

TestCase subclass: #TestBankAccountForceTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-BankAccount'!

!TestBankAccountForceTree methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 11:30'!
testAccount
	| customer args   customer2 |
	customer := Customer new.
	customer2 := Customer new.
	(customer account) decisionMetaObject: (BankAccountForceTree new).
	(customer2 account) decisionMetaObject: (BankAccountForceTree new).
	
	
	[customer2 transferForceTree: 10 to: customer2. self assert: false.] "We do not have enough money to transfer"
		on: Error 
		do: [
			Transcript show: (customer balance).
			self assert: ((customer balance) = 0.0). 
			self assert: ((customer2 balance) = 0.0). ].
	
	customer balance: 10.
	self assert: ((customer balance) = 10).
	[customer transferForceTree: 10.0 to: customer2. ] on: Error do: [self assert: false].
	self assert: ((customer balance) = 0).
	self assert: ((customer2 balance) = 10.0). 
	
	args := OrderedCollection new add: 5; add: (customer account); yourself.
	args := args asArray.
	
	[customer2 transferForceTree: 5 to: (customer account) ] on: Error do: [self assert: false].
	
	self assert: ((customer balance) = 5).
	self assert: ((customer2 balance) = 5.0). 
	
	"Customer has not so much money on account"
	[customer transferForceTree: 10.0 to: customer2. self assert: false] on: Error do: [self assert: true].! !

TestCase subclass: #TestBankAccountPerspectives
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-BankAccount'!

!TestBankAccountPerspectives methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 11:06'!
testAccount
	| bankAccount customer args |
	bankAccount := BankAccount new.
	customer := Customer new.
	bankAccount decisionMetaObject: (BankAccountPerspective new).
	(customer account) decisionMetaObject: (BankAccountPerspective new).
	customer perspective: (UserLayer new). "Setting perspective of user"
	
	[bankAccount transfer: 10 to: bankAccount. self assert: false.] "Here we are not allowed to transfer money, as we do not use perspectives!!"
		on: Error 
		do: [
			self assert: ((customer balance) = 0.0). 
			self assert: ((bankAccount balancethrough: (UserLayer new)) = 0.0). ].
	
	(customer account) balance: 10 through: (BankLayer new).
	self assert: (((customer account) balancethrough: (UserLayer new)) = 10).

	[customer transfer: 10.0 to: bankAccount. ] on: Error do: [self assert: false].
	self assert: ((customer balance) = 0).
	self assert: ((bankAccount balancethrough: (UserLayer new)) = 10.0). 
	
	[bankAccount transfer: 5 to: (customer account) through: (BankLayer new). ] on: Error do: [self assert: false].
	
	self assert: ((customer balance) = 5).
	self assert: ((bankAccount balancethrough: (UserLayer new)) = 5.0). 
	
	
	"Customer has not so much money on account"
	[customer transfer: 10.0 to: bankAccount. self assert: false] on: Error do: [self assert: true].! !

TestCase subclass: #TestBankAccountRoles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-BankAccount'!

!TestBankAccountRoles methodsFor: 'testing' stamp: 'DanielLangone 10/19/2010 09:14'!
testAccount
	| bankAccount customer args |
	bankAccount := BankAccount new.
	bankAccount decisionMetaObject: (BankAccountRolesDictionary new generateDecisionMetaObject).
	customer := Customer new.
	customer perspective: #user.
	customer account decisionMetaObject: (BankAccountRolesDictionary new generateDecisionMetaObject).
	
	[bankAccount transfer: 10 to: bankAccount. self assert: false.] "Here we are not allowed to transfer money, as we do not use perspectives!!"
		on: Error 
		do: [
			self assert: ((customer balance) = 0.0). 
			self assert: ((bankAccount balancethrough: #user) = 0.0). ].
	
	(customer account) balance: 10 through: #private.
	self assert: (((customer account) balancethrough: #user) = 10).

	[customer transfer: 10.0 to: bankAccount. ] on: Error do: [self assert: false].
	self assert: ((customer balance) = 0).
	self assert: ((bankAccount balancethrough: #user) = 10.0). 
	
	[bankAccount transfer: 5 to: (customer account) through: #private. ] on: Error do: [self assert: false].
	
	self assert: ((customer balance) = 5).
	self assert: ((bankAccount balancethrough: #user) = 5.0). 
	
	
	"Customer has not so much money on account"
	[customer transfer: 10.0 to: bankAccount. self assert: false] on: Error do: [self assert: true].! !

TestCase subclass: #TestCore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Core-Tests'!

!TestCore methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 16:05'!
testAquintance
	|aSubject aDecisionMetaObject messageInformation |
	"MockContextualElement returns 2. MockDecisionStrategyForContextualElement is decision strategy for this contextual element."
	
	aDecisionMetaObject := DecisionMetaObject new.
	aDecisionMetaObject register: (MockDecisionStrategy new) for:  #test. 
	aSubject := Subject decisionMetaObject: aDecisionMetaObject.
	
	self assert: ((aSubject testwithIdentity: 5) = 1).
	
	"Testing information of messageInformation for the previously send message"
	messageInformation := (aDecisionMetaObject decisionStrategyFor: #test) messageInformation.
	
	self assert: (messageInformation sender = self). "We are the sender of the message"
	self assert: (messageInformation receiver = aSubject).
	self assert: (messageInformation selector = #test).
	self assert: (messageInformation arguments = #()). 
	self assert: (messageInformation contextualElement = nil). 
	self assert: (messageInformation identityInstVar = 5).  
	
	"Remove decision Strategy"
	aSubject := Subject decisionMetaObject: nil.
	[aSubject testwithIdentity: 5. self assert: false] onDNU: #testwithIdentity: do: [self assert: true].! !

!TestCore methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:50'!
testContextualElementDoMethod
	| aContextualElement result anotherContextualElement |
	"do: can be used to execute a block among every child, beginning with the last ending with the first."
	aContextualElement := ContextualElement new.
	anotherContextualElement := ContextualElement new.
	result := OrderedCollection new.
	
	self assert: ((aContextualElement do: [:me :answer | (answer isNil) ifTrue: [1] ifFalse: [answer + 1]]) = 1).
	self assert: ((aContextualElement do: [:me :answer | me]) = aContextualElement).
	result := (aContextualElement do: [:me :answer | (result add: me). result]).
	self assert: ((result size) = 1).
	self assert: ((result at: 1) = aContextualElement).
	
	"Adding child to aContextualElement"
	aContextualElement child: (anotherContextualElement).
	
	self assert: ((aContextualElement do: [:me :answer | (answer isNil) ifTrue: [1] ifFalse: [answer + 1]]) = 2).
	self assert: ((aContextualElement do: [:me :answer | me]) = aContextualElement).
	
	result := OrderedCollection new.
	result := (aContextualElement do: [:me :answer | (result add: me). result]).
	self assert: ((result size) = 2).
	self assert: ((result at: 1) = anotherContextualElement).
	self assert: ((result at: 2) = aContextualElement)! !

!TestCore methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 14:22'!
testDecisionMetaObject
	|aDecisionMetaObject|
	aDecisionMetaObject := DecisionMetaObject new.
	"No decision strategy registered for message #test thus error"
	[aDecisionMetaObject decisionStrategyFor: #test. self assert: false] on: Error do: [self assert: true].

	"Registering instance of MockDecisionStrategy as decision strategy for message #test"
	aDecisionMetaObject register: (MockDecisionStrategy new) for: #test. 
	
	self assert: (((aDecisionMetaObject decisionStrategyFor: #test) class) = (MockDecisionStrategy)).! !

!TestCore methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 14:31'!
testMetaInformationDecisionStrategy
	|aSubject aDecisionMetaObject messageInformation |
	"Setup simple Subject. Decision Strategy will save the messageInformation"
	aDecisionMetaObject := DecisionMetaObject new.
	aDecisionMetaObject register: (MockDecisionStrategy new) for:  #test. 
	aDecisionMetaObject register: (MockDecisionStrategy new) for:  #test:. 
	aSubject := Subject decisionMetaObject: aDecisionMetaObject.
	
	self assert: (aSubject test = 1). "Just sending a message to access messageInformation"
	self assert: ((aSubject test: 10) = 1). "Just sending a message to access messageInformation"
	
	"Testing information of messageInformation for the previously send message #test"
	messageInformation := (aDecisionMetaObject decisionStrategyFor: #test) messageInformation.
	
	self assert: (messageInformation sender = self). "We are the sender of the message"
	self assert: (messageInformation receiver = aSubject).
	self assert: (messageInformation selector = #test).
	self assert: (messageInformation arguments = #()). 
	self assert: (messageInformation contextualElement = nil).  
	
	"Testing information of messageInformation for the previously send message"
	messageInformation := (aDecisionMetaObject decisionStrategyFor: #test:) messageInformation.
	
	self assert: (messageInformation sender = self). "We are the sender of the message #test:"
	self assert: (messageInformation receiver = aSubject).
	self assert: (messageInformation selector = #test:).
	self assert: (messageInformation arguments = #(10)). 
	self assert: (messageInformation contextualElement = nil).  ! !

!TestCore methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 14:16'!
testSimpleSubject
	|aSubject aDecisionMetaObject|
	"MockContextualElement overrides the default decideOn: method to return 1"
	
	aDecisionMetaObject := DecisionMetaObject new.
	aDecisionMetaObject register: (MockDecisionStrategy new) for:  #test. 
	
	"With no decision meta object there is no decision strategy for the message #test defined"
	[aSubject test. self assert: false.] onDNU: #test do: [self assert: true].
	
	"Adding decision meta object holding decision strategies"
	aSubject := Subject decisionMetaObject: aDecisionMetaObject.
	
	self assert: (aSubject test = 1).
	
	"Removing decision meta object holding decision strategies"
	aSubject decisionMetaObject: nil.
	
	[aSubject test. self assert: false.] onDNU: #test do: [self assert: true].
	
	
	! !

!TestCore methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 09:37'!
testSimpleSubjectWithContextualElements
	|aSubject aDecisionMetaObject messageInformation aContextalElement aContextalElementWithChild anotherContextalElementWithChild |
	"MockContextualElement returns 2. MockDecisionStrategyForContextualElement is decision strategy for this contextual element."
	
	aDecisionMetaObject := DecisionMetaObject new.
	aDecisionMetaObject register: (MockDecisionStrategyForContextualElement new) for:  #test. 
	
	aContextalElement := MockContextualElement new.
	aContextalElementWithChild := ContextualElement child: (MockContextualElement new).
	
	anotherContextalElementWithChild := MockContextualElement child: (ContextualElement new).
	aSubject := Subject decisionMetaObject: aDecisionMetaObject.
	
	self assert: ((aSubject testthrough: aContextalElement) = 2).
	
	"Testing information of messageInformation for the previously send message"
	messageInformation := (aDecisionMetaObject decisionStrategyFor: #test) messageInformation.
	
	self assert: (messageInformation sender = self). "We are the sender of the message"
	self assert: (messageInformation receiver = aSubject).
	self assert: (messageInformation selector = #test).
	self assert: (messageInformation arguments = #()). 
	self assert: (messageInformation contextualElement = aContextalElement).  
	
	self assert: ((aSubject testthrough: aContextalElementWithChild) = 2).
	
	"Testing information of messageInformation for the previously send message"
	messageInformation := (aDecisionMetaObject decisionStrategyFor: #test) messageInformation.
	
	self assert: (messageInformation sender = self). "We are the sender of the message"
	self assert: (messageInformation receiver = aSubject).
	self assert: (messageInformation selector = #test).
	self assert: (messageInformation arguments = #()). 
	self assert: (messageInformation contextualElement = aContextalElementWithChild).  
	
	self assert: ((aSubject testthrough: anotherContextalElementWithChild) = 2).
	
	"Testing information of messageInformation for the previously send message"
	messageInformation := (aDecisionMetaObject decisionStrategyFor: #test) messageInformation.
	
	self assert: (messageInformation sender = self). "We are the sender of the message"
	self assert: (messageInformation receiver = aSubject).
	self assert: (messageInformation selector = #test).
	self assert: (messageInformation arguments = #()). 
	self assert: (messageInformation contextualElement = anotherContextalElementWithChild).  
	
	
	"Remove decision Strategy"
	aSubject := Subject decisionMetaObject: nil.
	[aSubject testthrough: aContextalElement. self assert: false] onDNU: #testthrough: do: [self assert: true].! !

!TestCore methodsFor: 'testing' stamp: 'DanielLangone 10/23/2010 12:43'!
testSubclassedSubject
	|aSubject aDecisionMetaObject messageInformation aContextalElement |
	"Testing root element of hierarchy"
	aSubject := RootSubject new.
	self assert: (aSubject test = 3).
	
	
	aSubject := ChildSubject new.
	
	"It will throw an error as you do not have a Decision Strategy defined for the message test yet."
	[aSubject test. self assert: false.] on: Error do: [self assert: true].
	
	"Now it will work"
	aDecisionMetaObject := DecisionMetaObject new.
	aDecisionMetaObject register: (MockDecisionStrategy new) for:  #test. 
	aContextalElement := MockContextualElement new.
	aSubject decisionMetaObject: aDecisionMetaObject.
	
	self assert: (aSubject test = 1).! !

!TestCore methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 14:53'!
testSubject
	|aSubject aDecisionMetaObject messageInformation aContextalElement |
	"MockContextualElement returns 2. MockDecisionStrategyForContextualElement is decision strategy for this contextual element."
	
	aDecisionMetaObject := DecisionMetaObject new.
	aDecisionMetaObject register: (MockDecisionStrategyForContextualElement new) for:  #test. 
	aContextalElement := MockContextualElement new.
	aSubject := Subject decisionMetaObject: aDecisionMetaObject.
	self assert: ((aSubject testthrough: aContextalElement) = 2).
	
	"Testing information of messageInformation for the previously send message"
	messageInformation := (aDecisionMetaObject decisionStrategyFor: #test) messageInformation.
	
	self assert: (messageInformation sender = self). "We are the sender of the message"
	self assert: (messageInformation receiver = aSubject).
	self assert: (messageInformation selector = #test).
	self assert: (messageInformation arguments = #()). 
	self assert: (messageInformation contextualElement = aContextalElement).  
	
	"Remove decision Strategy"
	aSubject := Subject decisionMetaObject: nil.
	[aSubject testthrough: aContextalElement. self assert: false] onDNU: #testthrough: do: [self assert: true].! !

TestCase subclass: #TestMailSending
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!TestMailSending methodsFor: 'testing' stamp: 'DanielLangone 9/11/2010 11:32'!
testUserEquality
	|aUser aUser2 aUser3 |
	aUser := User mailAddress: 'd.langone@students.unibe.ch'.
	aUser2 := User mailAddress: 'd.langone@students.unibe.ch'.
	aUser3 := User mailAddress: 'juan@studenst.unibe.ch'.
	
	self assert: (aUser = aUser2).
	self assert: ((aUser = aUser3) not).
	
	aUser name: 'daniel'.
	self assert: ((aUser name) = 'daniel').
	self assert: ((aUser2 name) = 'daniel').! !

TestCase subclass: #TestMailSendingForceTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!TestMailSendingForceTree methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 16:15'!
testSimpleMailSending
	| mailDeliverer decisionMetaObject aUser aDevice aUser2 aMail room1 room2 |
	mailDeliverer := MailDeliverer new.
	room1 := Room new name: 'Room1'.
	room2 := Room new name: 'Room2'.
	
	decisionMetaObject := MailDelivererForceTree new.
	mailDeliverer decisionMetaObject: decisionMetaObject.
	
	aMail := Mail new.
	aMail sender: 'd.langone@students.unibe.ch'.
	aMail recipient: 'juan@students.unibe.ch'.
	aMail message: 'Hello World'.
	
	aUser := User mailAddress: 'd.langone@students.unibe.ch'.
	aUser mailDeliverer: mailDeliverer; name: 'daniel'.
	
	aUser2 := User mailAddress: 'juan@students.unibe.ch'.
	aUser2 mailDeliverer: mailDeliverer; name: 'juan'.
	
	aDevice := Device new.
	aDevice owner: aUser2.
	aUser device: aDevice.
	
	"Uses acquintance object"
	[aUser sendMail: aMail. self assert: false] on: Error do: [self assert: true].
	
	aDevice owner: aUser.
	aUser sendMail: aMail.
	[aUser sendMail: aMail. self assert: true] on: Error do: [self assert: false].

	aUser room: room1.
	aUser2 room: room1.
	self assert: ((aUser sendMail: aMail) = 2). "Returns 2 because fast delivery"
	
	aUser room: room1.
	aUser2 room: room2.
	self assert: ((aUser sendMail: aMail) = 1) "Returns 1 because normal delivery"! !

TestCase subclass: #TestMailSendingPerspective
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!TestMailSendingPerspective methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 10:08'!
testSimpleMailSending
	| mailDeliverer decisionMetaObject aUser aDevice aUser2 aMail room1 room2 |
	"Difficulty: The acquintance object can not easily be determined, thus we would need to hardcode this or use an external object registering all the users which are
	in the room. Thus we have not any advantage by using perspective"
	mailDeliverer := MailDeliverer new.
	mailDeliverer decisionMetaObject: (MailDelivererPerspective new).
	
	
	room1 := Room new name: 'Room1'.
	room2 := Room new name: 'Room2'.
		
	aMail := Mail new.
	aMail sender: 'd.langone@students.unibe.ch'.
	aMail recipient: 'juan@students.unibe.ch'.
	aMail message: 'Hello World'.
	
	aUser := User mailAddress: 'd.langone@students.unibe.ch'.
	aUser mailDeliverer: mailDeliverer; name: 'daniel'.
	
	aUser2 := User mailAddress: 'juan@students.unibe.ch'.
	aUser2 mailDeliverer: mailDeliverer; name: 'juan'.
	
	aDevice := Device new.
	aDevice owner: aUser2.
	aUser device: aDevice.
	[aUser sendMailPerspective: aMail. self assert: false] on: Error do: [self assert: true].
	
	aDevice owner: aUser.
	aUser sendMailPerspective: aMail.
	[self assert: ((aUser sendMailPerspective: aMail) = 1)] on: Error do: [self assert: false]. "Sends 1 as deliver succeded"! !

TestCase subclass: #TestMailSendingRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!TestMailSendingRole methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 17:19'!
testSimpleMailSending
	| mailDeliverer decisionMetaObject aUser aDevice aUser2 aMail room1 room2 |
	"Difficulty: The acquintance object can not easily be determined, thus we would need to hardcode this or use an external object registering all the users which are
	in the room. Thus we have not any advantage by using perspective"
	mailDeliverer := MailDeliverer new.
	decisionMetaObject := MailDelivererRolesDictionary new.
	decisionMetaObject := decisionMetaObject generateDecisionMetaObject.
	mailDeliverer decisionMetaObject: (DecisionMetaObject new register: (MailDelivererRolesDictionary new) for: #deliverRole:).
	
	room1 := Room new name: 'Room1'.
	room2 := Room new name: 'Room2'.
		
	aMail := Mail new.
	aMail sender: 'd.langone@students.unibe.ch'.
	aMail recipient: 'juan@students.unibe.ch'.
	aMail message: 'Hello World'.
	
	aUser := User mailAddress: 'd.langone@students.unibe.ch'.
	aUser mailDeliverer: mailDeliverer; name: 'daniel'.
	
	aUser2 := User mailAddress: 'juan@students.unibe.ch'.
	aUser2 mailDeliverer: mailDeliverer; name: 'juan'.
	
	aDevice := Device new.
	aDevice owner: aUser2.
	aUser device: aDevice.
	[aUser sendMailRole: aMail. self assert: false] on: Error do: [self assert: true].
	
	aDevice owner: aUser.
	(aUser sendMailRole: aMail).
	[self assert: ((aUser sendMailRole: aMail) = 1)] on: Error do: [self assert: false]. "Sends 1 as deliver succeded"! !

Object subclass: #ContextualElement
	instanceVariableNames: 'childContextualElement metaInformation subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Core'!

!ContextualElement class methodsFor: 'as yet unclassified' stamp: 'DanielLangone 10/15/2010 15:31'!
child: aContextualElement
	^(self basicNew child: aContextualElement)! !

!ContextualElement methodsFor: 'setting' stamp: 'DanielLangone 9/28/2010 09:33'!
child
	^childContextualElement! !

!ContextualElement methodsFor: 'setting' stamp: 'DanielLangone 9/6/2010 11:54'!
child: aContextualElement
	childContextualElement := aContextualElement.! !

!ContextualElement methodsFor: 'setting' stamp: 'DanielLangone 10/5/2010 16:41'!
childAtBegin: aContextualElement
	(childContextualElement isNil)
		ifTrue: [
				childContextualElement := aContextualElement
			]
		ifFalse: [
				aContextualElement child: childContextualElement.
				childContextualElement := aContextualElement
			]! !

!ContextualElement methodsFor: 'setting' stamp: 'DanielLangone 10/5/2010 15:15'!
childAtEnd: aContextualElement
	(childContextualElement isNil)
		ifTrue: [
				childContextualElement := aContextualElement
			]
		ifFalse: [
				childContextualElement childAtEnd: aContextualElement
			]! !

!ContextualElement methodsFor: 'decision' stamp: 'DanielLangone 10/18/2010 11:04'!
decideOn: aMessageSendInformation
	subject := aMessageSendInformation receiver.
	^((self class methodDictionary includesKey: (aMessageSendInformation selector)) 
		ifTrue: [
			self run: (aMessageSendInformation selector) with: (aMessageSendInformation arguments). 
		] ifFalse: [
			(childContextualElement isNil) 
				ifTrue: [
					(aMessageSendInformation receiver) run: (aMessageSendInformation selector) with: (aMessageSendInformation arguments)]
				ifFalse: [
					(childContextualElement decideOn: aMessageSendInformation).].
		]). 
	! !

!ContextualElement methodsFor: 'enumerating' stamp: 'DanielLangone 10/5/2010 13:19'!
do: aBlock
	|answer|
	answer := (childContextualElement isNil not) ifTrue: [childContextualElement do: aBlock] ifFalse: [nil].
	^(aBlock value: self value: answer).! !

!ContextualElement methodsFor: 'initialize-release' stamp: 'DanielLangone 9/6/2010 12:01'!
initialize 
	childContextualElement := nil.! !

!ContextualElement methodsFor: 'execution' stamp: 'DanielLangone 10/11/2010 15:28'!
run: aBinaryString with: anArray
	| method |
	method := (self class lookupSelector: (aBinaryString)).
	^(method isNil) ifFalse: [(((self class methodDictionary at: (aBinaryString)) numArgs) = 0) 
		ifTrue: [
			(self executeMethod: method)
		]
		ifFalse: [
			(self withArgs: (anArray) executeMethod: method)
		].]
	ifTrue: [self error: self class asString, ' does not understand: ', aBinaryString asString.]! !

ContextualElement subclass: #MockContextualElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Core-Tests'!

!MockContextualElement methodsFor: 'decision' stamp: 'DanielLangone 10/15/2010 14:44'!
decideOn: aMessageSendInformation
	^2! !

ContextualElement subclass: #PerspectiveLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Perspective'!

PerspectiveLayer subclass: #AddLine
	instanceVariableNames: 'code line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Group Programming'!

!AddLine methodsFor: 'setting' stamp: 'DanielLangone 10/18/2010 14:36'!
code: aString
	code := aString! !

!AddLine methodsFor: 'setting' stamp: 'DanielLangone 10/18/2010 14:36'!
line: anInteger
	line := anInteger.! !

!AddLine methodsFor: 'manipulation' stamp: 'DanielLangone 10/18/2010 14:46'!
manipulate: anOrderedCollection
	anOrderedCollection at: line ifAbsentPut: [''].
	anOrderedCollection at: line put: code.! !

PerspectiveLayer subclass: #AuthorizationLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!AuthorizationLayer methodsFor: 'testing' stamp: 'DanielLangone 10/8/2010 11:39'!
deliverPerspective: aMail
	^1! !

PerspectiveLayer subclass: #DeleteLine
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Group Programming'!

!DeleteLine methodsFor: 'accessing' stamp: 'DanielLangone 10/5/2010 16:56'!
line: anInteger
	line := anInteger! !

!DeleteLine methodsFor: 'manipulating' stamp: 'DanielLangone 10/18/2010 15:12'!
manipulate: anOrderedCollection
	(anOrderedCollection size >= line) ifTrue: [anOrderedCollection removeAt: line].! !

PerspectiveLayer subclass: #InstanceVariableLayerAccess
	instanceVariableNames: 'instanceVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Perspective'!

!InstanceVariableLayerAccess methodsFor: 'decision' stamp: 'DanielLangone 10/18/2010 11:04'!
decideOn: aMessageInformation 
	subject := aMessageInformation receiver.
	^((aMessageInformation selector = instanceVariable) ifFalse: [super decideOn: aMessageInformation] ifTrue: [
	(aMessageInformation receiver instVarNamed: instanceVariable)])! !

!InstanceVariableLayerAccess methodsFor: 'setting' stamp: 'DanielLangone 10/18/2010 09:43'!
instanceVariableName: aString
	instanceVariable := aString asString.! !

InstanceVariableLayerAccess subclass: #PrivateAccessLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Private Variable'!

!PrivateAccessLayer methodsFor: 'initialization' stamp: 'DanielLangone 10/8/2010 16:19'!
initialize 
	super initialize.
	self instanceVariableName: #privateVariable! !

InstanceVariableLayerAccess subclass: #UserLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-BankAccount'!

!UserLayer methodsFor: 'initialize-release' stamp: 'DanielLangone 10/8/2010 14:20'!
initialize 
	super initialize.
	self instanceVariableName: #balance.! !

!UserLayer methodsFor: 'transfer' stamp: 'DanielLangone 10/18/2010 11:02'!
transfer: anInteger to: aBankAccount
	| balanceTransfer balanceCustomer anArray |
	((subject balanceThrough: (UserLayer new)) >= anInteger) ifFalse: [self error: 'You have not enough money.'].
	
	balanceTransfer := (aBankAccount balancethrough: (UserLayer new)) + (anInteger).
	balanceCustomer :=(subject balancethrough: (UserLayer new)) - (anInteger).
	
	aBankAccount balance: balanceTransfer through: (BankLayer new).
	subject balance: balanceCustomer through: (BankLayer new).

	^(aBankAccount)! !

PerspectiveLayer subclass: #InstanceVariableLayerModification
	instanceVariableNames: 'instanceVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Perspective'!

InstanceVariableLayerModification subclass: #BankLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-BankAccount'!

!BankLayer methodsFor: 'initialize-release' stamp: 'DanielLangone 10/18/2010 10:36'!
initialize 
	super initialize.
	self instanceVariableName: #balance.
	self child: (UserLayer new).! !

!InstanceVariableLayerModification methodsFor: 'decision' stamp: 'DanielLangone 10/18/2010 11:06'!
decideOn: aMessageInformation 
	subject := aMessageInformation receiver.
	
	^((aMessageInformation selector = (instanceVariable,':')) ifFalse: [super decideOn: aMessageInformation] ifTrue: [
		((aMessageInformation arguments size) = 1) ifFalse: [self error: 'You can not change the instance variable, because of arguments.'].
	(aMessageInformation receiver instVarNamed: instanceVariable put: ((aMessageInformation arguments) at: 1))])! !

!InstanceVariableLayerModification methodsFor: 'setting' stamp: 'DanielLangone 10/18/2010 09:48'!
instanceVariableName: aString
	instanceVariable := aString asString.! !

InstanceVariableLayerModification subclass: #PrivateModificationLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Private Variable'!

!PrivateModificationLayer methodsFor: 'initialization' stamp: 'DanielLangone 10/8/2010 16:18'!
initialize 
	super initialize.
	self instanceVariableName: #privateVariable! !

PerspectiveLayer subclass: #MockLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Perspective-Tests'!

!MockLayer methodsFor: 'testing' stamp: 'DanielLangone 10/7/2010 15:28'!
test
	^1! !

!PerspectiveLayer methodsFor: 'decision' stamp: 'DanielLangone 10/18/2010 11:04'!
decideOn: aMessageSendInformation
	subject := aMessageSendInformation receiver.
	^((self class methodDictionary includesKey: (aMessageSendInformation selector)) 
	ifTrue: [self run: (aMessageSendInformation selector) with: (aMessageSendInformation arguments). ] 
	ifFalse: [super decideOn: aMessageSendInformation])! !

PerspectiveLayer subclass: #Programmer
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Group Programming'!

!Programmer methodsFor: 'manipulating' stamp: 'DanielLangone 10/18/2010 15:05'!
addLine: aString at: anInteger
	self childAtBegin: (AddLine new code: aString; line: anInteger)! !

!Programmer methodsFor: 'accessing' stamp: 'DanielLangone 10/18/2010 15:08'!
code
	| code |
	code := subject copy asOrderedCollection.
	self do: 
		[:layer :answer | 
			layer manipulate: code.
		].
	^(SourceCode new code: code).! !

!Programmer methodsFor: 'manipulating' stamp: 'DanielLangone 10/18/2010 15:05'!
deleteLineAt: anInteger
	self childAtBegin: (DeleteLine new line: anInteger)! !

!Programmer methodsFor: 'manipulating' stamp: 'DanielLangone 10/18/2010 14:46'!
manipulate: anOrderedCollection
	^anOrderedCollection! !

!Programmer methodsFor: 'accessing' stamp: 'DanielLangone 10/5/2010 16:28'!
name 
	^name ! !

!Programmer methodsFor: 'setting' stamp: 'DanielLangone 10/4/2010 17:27'!
name: aString
	name := aString! !

ContextualElement subclass: #Role
	instanceVariableNames: 'roleMethodDictionary methodAdd methodChange methodHide'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Role'!

Role subclass: #AuthorizationRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!AuthorizationRole methodsFor: 'changed methods' stamp: 'DanielLangone 10/19/2010 09:25'!
changedeliverRole: aMail
	^1! !

Role subclass: #BankRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-BankAccount'!

!BankRole methodsFor: 'changed methods' stamp: 'DanielLangone 10/19/2010 09:25'!
changebalance: anInteger
	subject instVarNamed: #balance put: anInteger! !

Role subclass: #MockRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Role-Tests'!

!MockRole methodsFor: 'building' stamp: 'DanielLangone 10/19/2010 09:26'!
addtest2
	^3! !

!MockRole methodsFor: 'building' stamp: 'DanielLangone 10/19/2010 09:26'!
changetest
	^2! !

Role subclass: #PrivateRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Private Variable'!

!PrivateRole methodsFor: 'setting' stamp: 'DanielLangone 10/14/2010 11:24'!
addprivateVariable
	^(subject instVarNamed: #privateVariable)! !

!PrivateRole methodsFor: 'setting' stamp: 'DanielLangone 10/14/2010 11:23'!
addprivateVariable: anObject
	^(subject instVarNamed: #privateVariable put: anObject)! !

!Role methodsFor: 'decision' stamp: 'DanielLangone 10/19/2010 09:24'!
decideOn: aMessageSendInformation
	subject := aMessageSendInformation receiver.
	^((roleMethodDictionary includesKey: (aMessageSendInformation selector)) 
		ifTrue: [
			self run: (roleMethodDictionary at: (aMessageSendInformation selector)) with: (aMessageSendInformation arguments).]	
		ifFalse: [
			(childContextualElement isNil) 
				ifFalse: [
						childContextualElement decideOn: aMessageSendInformation.
					]
				ifTrue: [
					self run: (aMessageSendInformation selector) with: (aMessageSendInformation arguments)
					]
			])! !

!Role methodsFor: 'initialize-release' stamp: 'DanielLangone 10/11/2010 14:30'!
initialize
	super initialize.
	roleMethodDictionary := Dictionary new.
	methodAdd := 'add'.
	methodChange := 'change'.
	methodHide := 'hide'.
	self registerMethods.! !

!Role methodsFor: 'building' stamp: 'DanielLangone 10/19/2010 09:22'!
registerMethods
	"Those methods beginning with add, change or hide are registered only"
	((self class = Role) not) ifTrue: [
		self class methodDictionary keysDo: [:each |
				((each asLowercase beginsWith: methodAdd) and: [(each size - methodAdd size ) > 0])  ifTrue: [
					roleMethodDictionary at: ((each copyFrom: (methodAdd size + 1) to: (each size))) put: each].
				
				((each asLowercase beginsWith: methodChange) and: [(each size - methodChange size) > 0])  ifTrue: [
					roleMethodDictionary at: ((each copyFrom: (methodChange size + 1) to: (each size))) put: each].
				
				((each asLowercase beginsWith: methodHide) and: [(each size - methodHide size) > 0]) ifTrue: [
					self class compile:( each , String cr , 'self error: ''Method not available!!''').
					roleMethodDictionary at:((each copyFrom: (methodHide size + 1) to: (each size))) put: each].
			]
	]! !

Role subclass: #UserRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-BankAccount'!

!UserRole methodsFor: 'changed methods' stamp: 'DanielLangone 10/19/2010 09:25'!
changebalance
 ^ (subject instVarNamed: #balance)! !

!UserRole methodsFor: 'changed methods' stamp: 'DanielLangone 10/19/2010 09:26'!
changetransfer: anInteger to: aBankAccount
	| balanceTransfer balanceCustomer anArray |
	((subject balanceThrough: #user) >= anInteger) ifFalse: [self error: 'You have not enough money.'].
	
	balanceTransfer := (aBankAccount balancethrough: #user) + (anInteger).
	balanceCustomer :=(subject balancethrough: #user) - (anInteger).
	
	aBankAccount balance: balanceTransfer through: #private.
	subject balance: balanceCustomer through: #private.

	^(aBankAccount)! !

Object subclass: #Customer
	instanceVariableNames: 'balance myAccount myPerspective'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-BankAccount'!

!Customer methodsFor: 'accessing' stamp: 'DanielLangone 9/30/2010 13:52'!
account 
	^myAccount ! !

!Customer methodsFor: 'accessing' stamp: 'DanielLangone 10/19/2010 09:10'!
balance 
	(myAccount balanceThrough: myPerspective).
	^[(myAccount balanceThrough: myPerspective)] on: Error do: [myAccount balance]! !

!Customer methodsFor: 'setting' stamp: 'DanielLangone 10/18/2010 11:21'!
balance: anInteger
	myAccount balance: anInteger! !

!Customer methodsFor: 'initialize-release' stamp: 'DanielLangone 10/18/2010 10:26'!
initialize 
	myAccount := BankAccount new.
	myPerspective := PerspectiveLayer new.! !

!Customer methodsFor: 'setting' stamp: 'DanielLangone 10/18/2010 17:23'!
perspective: aPerspective
	myPerspective := aPerspective! !

!Customer methodsFor: 'transfer' stamp: 'DanielLangone 10/18/2010 10:32'!
transfer: anInteger to: aBankaccount
	^ (myAccount transfer: anInteger to: aBankaccount through: myPerspective)! !

!Customer methodsFor: 'transfer' stamp: 'DanielLangone 10/18/2010 11:07'!
transferForceTree: anInteger to: aBankaccount
	^ (myAccount transfer: anInteger to: aBankaccount)! !

Object subclass: #DecisionMetaObject
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Core'!

DecisionMetaObject subclass: #BankAccountForceTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-BankAccount'!

!BankAccountForceTree methodsFor: 'building' stamp: 'DanielLangone 10/18/2010 11:19'!
buildBalance
| senderDeterminant notAuthorizedDeterminant accessInstanceVariableDeterminant |
	senderDeterminant := SenderDeterminant new.
	senderDeterminant decision: [:sender | ((sender class) = Customer) or: [(sender class) = BankAccount]].
	
	accessInstanceVariableDeterminant := InstanceDeterminant new.
	accessInstanceVariableDeterminant decision: #balance.
	
	notAuthorizedDeterminant := MethodDeterminant new.
	notAuthorizedDeterminant decision: #notAuthorized.
	
	senderDeterminant  falseDeterminant: notAuthorizedDeterminant; trueDeterminant: accessInstanceVariableDeterminant.
	
	self register: senderDeterminant for: #balance.! !

!BankAccountForceTree methodsFor: 'building' stamp: 'DanielLangone 10/18/2010 11:18'!
buildBalanceManipulation
| senderDeterminant notAuthorizedDeterminant modifyInstanceVariableDeterminant |
	senderDeterminant := SenderDeterminant new.
	senderDeterminant decision: [:sender | ((sender class) = Customer) or: [(sender class) = BankAccount]].
	
	modifyInstanceVariableDeterminant := InstanceManipulateDeterminant new.
	modifyInstanceVariableDeterminant decision: #balance.
	
	notAuthorizedDeterminant := MethodDeterminant new.
	notAuthorizedDeterminant decision: #notAuthorized.
	
	senderDeterminant  falseDeterminant: notAuthorizedDeterminant; trueDeterminant: modifyInstanceVariableDeterminant.
	
	self register: senderDeterminant for: #balance:.! !

!BankAccountForceTree methodsFor: 'building' stamp: 'DanielLangone 10/18/2010 11:31'!
buildTransferTo
| authorizationFailedDeterminant senderDeterminant presenceDeterminant deliverNormal deliverFast authorizedDeterminant enoughtMoneyDeterminant notEnoughMoneyDeterminant |
	senderDeterminant := SenderDeterminant new.
	senderDeterminant decision: [:sender | ((sender class) = Customer) or: [(sender class) = BankAccount]].
	
	authorizationFailedDeterminant := MethodDeterminant new.
	authorizationFailedDeterminant decision: #notAuthorized.
	
	notEnoughMoneyDeterminant := MethodDeterminant new.
	notEnoughMoneyDeterminant decision: #notEnoughMoney.
	
	enoughtMoneyDeterminant := MiscDeterminant new.
	enoughtMoneyDeterminant decision: [:misc | ((misc arguments at: 1) > 0) and: [((misc sender balance) >= (misc arguments at: 1))]].
	
	authorizedDeterminant := MethodDeterminant new.
	authorizedDeterminant decision: #realTransfer:to:.
	
	senderDeterminant  falseDeterminant: authorizationFailedDeterminant; trueDeterminant: enoughtMoneyDeterminant.
	enoughtMoneyDeterminant  falseDeterminant: notEnoughMoneyDeterminant; trueDeterminant: authorizedDeterminant.
	
	self register: senderDeterminant for: #transfer:to:.! !

DecisionMetaObject subclass: #BankAccountPerspective
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-BankAccount'!

!BankAccountPerspective methodsFor: 'building' stamp: 'DanielLangone 10/18/2010 10:34'!
buildPerspectives
	self register: (Perspective new) for: #transfer:to:.
	self register: (Perspective new) for: #balance:.
	self register: (Perspective new) for: #balance.! !

!DecisionMetaObject methodsFor: 'building' stamp: 'DanielLangone 10/7/2010 14:36'!
buildDictionary
	((self class = DecisionMetaObject) not) ifTrue: [
		self class methods do: [:each | (each numArgs = 0) ifTrue: [each valueWithReceiver: self arguments: #()]]
	]! !

!DecisionMetaObject methodsFor: 'enumerating' stamp: 'DanielLangone 11/5/2010 16:06'!
collectKeys: aBlock 
	^(OrderedCollection newFrom: (self dictionary keys collect: aBlock))! !

!DecisionMetaObject methodsFor: 'enumerating' stamp: 'DanielLangone 11/5/2010 16:07'!
collectValues: aBlock 
	^(OrderedCollection newFrom: (self dictionary values collect: aBlock))! !

!DecisionMetaObject methodsFor: 'decision' stamp: 'DanielLangone 10/15/2010 15:59'!
decideOn: aMessage with: aContext from: aSubject
	| metaInformation information anObject |
	
	information := self extractInformationFrom: aMessage.
	
	metaInformation := MessageSendInformation new.
	
	metaInformation receiver: (aSubject).
	metaInformation sender: (self sender: aContext).
	
	metaInformation arguments: (information at: 3).
	metaInformation selector: (information at: 1).
	metaInformation contextualElement: (information at: 2).
	metaInformation identityInstVar: (information at: 4).
	
	^((dictionary at: (information at: 1)) decideOn: metaInformation).! !

!DecisionMetaObject methodsFor: 'setting' stamp: 'DanielLangone 10/15/2010 14:22'!
decisionStrategyFor: aBinaryString
	^ (dictionary at: aBinaryString)! !

!DecisionMetaObject methodsFor: 'accessing' stamp: 'DanielLangone 9/9/2010 15:59'!
dictionary 
	^dictionary! !

!DecisionMetaObject methodsFor: 'enumerating' stamp: 'DanielLangone 11/5/2010 13:06'!
do: aBlock
	^(dictionary valuesDo: aBlock)! !

!DecisionMetaObject methodsFor: 'testing' stamp: 'DanielLangone 10/19/2010 09:23'!
exists: aMessage
	| information |
	information := self extractInformationFrom: aMessage.
	^([dictionary at: (information at: 1). true] on: Error do: [false.])! !

!DecisionMetaObject methodsFor: 'extraction' stamp: 'DanielLangone 10/15/2010 16:05'!
extractInformationFrom: aMessage
	| subSelector perspectiveSelector perspective arguments aquintanceObject aquintanceSelector |
	" The positions information
	1. Selector withouth 'through:'
	2. Perspective
	3. Arguments without perspectives name.
	4. Aquintance Object
	"
	perspectiveSelector := 'through:'.
	aquintanceSelector := 'withidentity:'.
	
	subSelector := aMessage selector asString.
	arguments := aMessage arguments.
	
	(((subSelector size) > (aquintanceSelector size)) and: [subSelector asLowercase endsWith: aquintanceSelector]) 
		ifTrue: [
				subSelector := (subSelector truncateTo: (((aMessage selector asString) size) - (aquintanceSelector asString size))) asSymbol.
				aquintanceObject := ((aMessage arguments) at: ((aMessage arguments) size)).
				arguments := ((aMessage arguments) asOrderedCollection) removeAt: ((aMessage arguments) size); yourself; asArray.
			].
		
	(((subSelector size) > (perspectiveSelector size)) and: [subSelector asLowercase endsWith: perspectiveSelector]) 
		ifTrue: [
			subSelector := (subSelector truncateTo: (((aMessage selector asString) size) - (perspectiveSelector asString size))) asSymbol.
			perspective := ((aMessage arguments) at: ((aMessage arguments) size)).
			arguments := ((aMessage arguments) asOrderedCollection) removeAt: ((aMessage arguments) size); yourself; asArray.
		].
	
	^(OrderedCollection new add: subSelector; yourself; add: perspective; yourself; add: arguments; yourself; add: aquintanceObject; yourself; asArray)
	! !

!DecisionMetaObject methodsFor: 'extraction' stamp: 'DanielLangone 10/23/2010 12:38'!
extractInformationFromContext: aContext
	| subSelector perspectiveSelector perspective arguments aquintanceObject aquintanceSelector |
	" The positions information
	1. Selector withouth 'through:'
	2. Perspective
	3. Arguments without perspectives name.
	4. Aquintance Object
	"
	perspectiveSelector := 'through:'.
	aquintanceSelector := 'withidentity:'.
	
	subSelector := aContext method selector asString.
	arguments := aContext arguments.
	
	(((subSelector size) > (aquintanceSelector size)) and: [subSelector asLowercase endsWith: aquintanceSelector]) 
		ifTrue: [
				subSelector := (subSelector truncateTo: (((aContext method selector asString) size) - (aquintanceSelector asString size))) asSymbol.
				aquintanceObject := ((aContext arguments) at: ((aContext arguments) size)).
				arguments := ((aContext arguments) asOrderedCollection) removeAt: ((aContext arguments) size); yourself; asArray.
			].
		
	(((subSelector size) > (perspectiveSelector size)) and: [subSelector asLowercase endsWith: perspectiveSelector]) 
		ifTrue: [
			subSelector := (subSelector truncateTo: (((aContext method selector asString) size) - (perspectiveSelector asString size))) asSymbol.
			perspective := ((aContext arguments) at: ((aContext arguments) size)).
			arguments := ((aContext arguments) asOrderedCollection) removeAt: ((aContext arguments) size); yourself; asArray.
		].
	
	^(OrderedCollection new add: subSelector; yourself; add: perspective; yourself; add: arguments; yourself; add: aquintanceObject; yourself; asArray)
	! !

!DecisionMetaObject methodsFor: 'decision' stamp: 'DanielLangone 10/26/2010 09:56'!
for: aSubject context: aContext withIdentity: anObject
	| metaInformation information|
	information := self extractInformationFromContext: aContext.
	
	metaInformation := MessageSendInformation new.
	
	metaInformation receiver: (aSubject).
	metaInformation sender: (self sender: aContext).
	
	metaInformation arguments: (information at: 3).
	metaInformation selector: (information at: 1).
	metaInformation contextualElement: (information at: 2).
	metaInformation identityInstVar: (anObject).
	[dictionary at: (information at: 1)] on: Error do: [self error: (aSubject class name) asString, ' does not understand ', (information at: 1) asString].
	^((dictionary at: (information at: 1)) decideOn: metaInformation).! !

!DecisionMetaObject methodsFor: 'initialize-release' stamp: 'DanielLangone 9/9/2010 14:30'!
initialize 
	super initialize.
	dictionary := Dictionary new.
	self buildDictionary.! !

!DecisionMetaObject methodsFor: 'register' stamp: 'DanielLangone 9/7/2010 11:29'!
register: aDecissionStrategy for: aBinaryString
	dictionary at: aBinaryString put: aDecissionStrategy.! !

!DecisionMetaObject methodsFor: 'setting' stamp: 'DanielLangone 10/15/2010 13:36'!
sender: aContext
	^([aContext sender receiver] on: Error do: [nil])! !

!DecisionMetaObject methodsFor: 'updating' stamp: 'DanielLangone 11/5/2010 16:38'!
update: aSubject
	self dictionary valuesDo: [:value | value update: aSubject]! !

DecisionMetaObject subclass: #FAMIXClassDecisionMetaObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Moose-FAMIXClass'!

!FAMIXClassDecisionMetaObject methodsFor: 'building' stamp: 'DanielLangone 11/4/2010 09:58'!
registerSubjectiveMethods
	self register: (ViewSystemComplexitiyStrategy new) for: #viewSystemComplexity.
	self register: (ViewSystemComplexitiyOnStrategy new) for: #viewSystemComplexityOn:.
	self register: (ShowDuplication new) for: #viewDuplication.! !

DecisionMetaObject subclass: #MailDelivererForceTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!MailDelivererForceTree methodsFor: 'building' stamp: 'DanielLangone 9/7/2010 15:04'!
deliverMail
	| authorizationFailedDeterminant senderDeterminant presenceDeterminant deliverNormal deliverFast |
	senderDeterminant := SenderDeterminant new.
	senderDeterminant decision: [:sender | sender = (sender device owner)].
	
	authorizationFailedDeterminant := MethodDeterminant new.
	authorizationFailedDeterminant decision: #authorizationFailure.
		
	presenceDeterminant := AquintanceDeterminant new.
	presenceDeterminant decision: [:mailReceiver :meta | (mailReceiver room) = ((meta sender) room)].
	presenceDeterminant classDecision: User.
	presenceDeterminant identity: #mailaddress.
	
	deliverNormal := MethodDeterminant new.
	deliverNormal decision: #deliverNormal.
	
	deliverFast := MethodDeterminant new.
	deliverFast decision: #deliverFast.
	
	senderDeterminant  falseDeterminant: authorizationFailedDeterminant; trueDeterminant: presenceDeterminant.
	presenceDeterminant  falseDeterminant: deliverNormal; trueDeterminant: deliverFast.
	
	self register: senderDeterminant for: #deliver:.! !

DecisionMetaObject subclass: #MailDelivererPerspective
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!MailDelivererPerspective methodsFor: 'building' stamp: 'DanielLangone 10/18/2010 10:04'!
authorizedPerspective
	self register:  (Perspective new) for: #deliverPerspective:.! !

DecisionMetaObject subclass: #MockForceTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree-Tests'!

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 10/12/2010 09:42'!
forceTreeComplex
	| receiverDeterminant receiverDeterminant2 senderDeterminant argumentDeterminant methodDeterminant1 methodDeterminant2 methodDeterminant3 methodDeterminant4  methodDeterminant5 |
	
	receiverDeterminant := ReceiverDeterminant new.
	receiverDeterminant2 := ReceiverDeterminant new.
	senderDeterminant := SenderDeterminant new.
	argumentDeterminant := ArgumentsDeterminant new.
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant3 := MethodDeterminant new.
	methodDeterminant4 := MethodDeterminant new.
	methodDeterminant5 := MethodDeterminant new.
	
	receiverDeterminant  decision: [:receiver | receiver someValue < 5].
	receiverDeterminant2  decision: [:receiver | receiver someValue < 2].
	senderDeterminant  decision: [:sender | sender myValue = 5].
	argumentDeterminant decision: [:arg | (arg at: 1) = 5].
	
	methodDeterminant1 decision: #returnOne.
	methodDeterminant2 decision: #returnTwo.
	methodDeterminant3 decision: #returnThree.
	methodDeterminant4 decision: #returnFour.
	methodDeterminant5 decision: #returnFive.
	
	receiverDeterminant trueDeterminant: receiverDeterminant2 ; falseDeterminant: senderDeterminant.
	receiverDeterminant2 trueDeterminant: argumentDeterminant ; falseDeterminant: methodDeterminant3 .
	senderDeterminant trueDeterminant: methodDeterminant4 ; falseDeterminant: methodDeterminant5.
	argumentDeterminant trueDeterminant: methodDeterminant1 ; falseDeterminant: methodDeterminant2.
	
	self register: receiverDeterminant for: #complexMessage:.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 10/15/2010 16:07'!
forceTreeForAcquintanceDeterminant
	| acqDeterminant methodDeterminant1 methodDeterminant2 |
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant1 decision: #returnOne.
	
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant2 decision:  #returnTwo.
	
	acqDeterminant := AquintanceDeterminant new.
	acqDeterminant classDecision: MockObject.
	acqDeterminant identity: #id.
	
	acqDeterminant decision: [:acqObj :meta| (acqObj myValue) = 10].
	acqDeterminant trueDeterminant: methodDeterminant1; falseDeterminant: methodDeterminant2.
	
	self register: acqDeterminant for: #acquintanceDeterminant.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:31'!
forceTreeForArgumentArgumentDeterminant
	| argumentDeterminant methodDeterminant1 methodDeterminant2 methodDeterminant3 argumentDeterminant2 |
	argumentDeterminant := ArgumentsDeterminant new.
	argumentDeterminant2 := ArgumentsDeterminant new.
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant3 := MethodDeterminant new.
	
	argumentDeterminant decision: [:arg | (arg at: 1) < 5].
	argumentDeterminant2 decision: [:arg | (arg at: 1) = 2].
	methodDeterminant1 decision: #returnOne.
	methodDeterminant2 decision: #returnTwo.
	methodDeterminant3 decision: #returnThree.
	
	argumentDeterminant trueDeterminant: argumentDeterminant2; falseDeterminant: methodDeterminant3.
	argumentDeterminant2 trueDeterminant: methodDeterminant1; falseDeterminant: methodDeterminant2.
	
	self register: argumentDeterminant for: #argumentArgumentDeterminant:.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:20'!
forceTreeForArgumentNotRoot
	| senderDeterminant argumentDeterminant methodDeterminant1 methodDeterminant2 methodDeterminant3 |
	senderDeterminant := SenderDeterminant new.
	argumentDeterminant := ArgumentsDeterminant new.
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant3 := MethodDeterminant new.
	
	senderDeterminant decision: [:sender | sender myValue < 5].
	argumentDeterminant decision: [:arg | (arg at: 1) = 5].
	methodDeterminant1 decision: #returnOne.
	methodDeterminant2 decision: #returnTwo.
	methodDeterminant3 decision: #returnThree.
	
	senderDeterminant trueDeterminant: argumentDeterminant; falseDeterminant: methodDeterminant3.
	argumentDeterminant trueDeterminant: methodDeterminant1; falseDeterminant: methodDeterminant2.
	
	self register: senderDeterminant for: #argumentNotRootOfTree:.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:34'!
forceTreeForArgumentsDeterminant
	| argumentsDeterminant methodDeterminant2 methodDeterminant1 |
	argumentsDeterminant := ArgumentsDeterminant new.
	argumentsDeterminant  decision: [:argument | (argument at: 1)= 5].
	
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant1 decision: #returnPlusOne:.
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant2 decision: #returnPlusTwo:.
	argumentsDeterminant trueDeterminant: methodDeterminant1 ; falseDeterminant: methodDeterminant2.
	
	self register: argumentsDeterminant  for: #argumentsDeterminant:.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:03'!
forceTreeForComplexMessage
	| receiverDeterminant receiverDeterminant2 senderDeterminant argumentDeterminant methodDeterminant1 methodDeterminant2 methodDeterminant3 methodDeterminant4  methodDeterminant5 |
	
	receiverDeterminant := ReceiverDeterminant new.
	receiverDeterminant2 := ReceiverDeterminant new.
	senderDeterminant := SenderDeterminant new.
	argumentDeterminant := ArgumentsDeterminant new.
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant3 := MethodDeterminant new.
	methodDeterminant4 := MethodDeterminant new.
	methodDeterminant5 := MethodDeterminant new.
	
	receiverDeterminant  decision: [:receiver | receiver someValue < 5].
	receiverDeterminant2  decision: [:receiver | receiver someValue < 2].
	senderDeterminant  decision: [:sender | sender myValue = 5].
	argumentDeterminant decision: [:arg | (arg at: 1) = 5].
	
	methodDeterminant1 decision: #returnOne.
	methodDeterminant2 decision: #returnTwo.
	methodDeterminant3 decision: #returnThree.
	methodDeterminant4 decision: #returnFour.
	methodDeterminant5 decision: #returnFive.
	
	receiverDeterminant trueDeterminant: receiverDeterminant2 ; falseDeterminant: senderDeterminant.
	receiverDeterminant2 trueDeterminant: argumentDeterminant ; falseDeterminant: methodDeterminant3 .
	senderDeterminant trueDeterminant: methodDeterminant4 ; falseDeterminant: methodDeterminant5.
	argumentDeterminant trueDeterminant: methodDeterminant1 ; falseDeterminant: methodDeterminant2.
	
	self register: receiverDeterminant for: #complexMessage:.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:38'!
forceTreeForMethodDeterminant
	| methodDeterminant |
	methodDeterminant := MethodDeterminant new.
	methodDeterminant decision: #returnOne.
	
	self register: methodDeterminant for: #methodDeterminant.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:37'!
forceTreeForMethodDeterminantWithArguments
	| methodDeterminant |
	methodDeterminant := MethodDeterminant new.
	methodDeterminant decision: #returnPlusOne:.
	
	self register: methodDeterminant for: #methodDeterminant:.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:34'!
forceTreeForReceiverDeterminantNoArguments
	| receiverDeterminant methodDeterminant2 methodDeterminant1 |
	receiverDeterminant := ReceiverDeterminant new.
	receiverDeterminant  decision: [:some | some someValue = 5].
	
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant1 decision: #returnOne.
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant2 decision: #returnTwo.
	receiverDeterminant trueDeterminant: methodDeterminant1 ; falseDeterminant: methodDeterminant2.
	
	self register: receiverDeterminant  for: #receiverDeterminantNoArguments.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:23'!
forceTreeForReceiverNotRoot
	| argumentDeterminant methodDeterminant1 methodDeterminant2 methodDeterminant3 receiverDeterminant |
	receiverDeterminant := ReceiverDeterminant new.
	argumentDeterminant := ArgumentsDeterminant new.
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant3 := MethodDeterminant new.
	
	argumentDeterminant decision: [:arg | (arg at: 1) < 5].
	receiverDeterminant decision: [:receiver | receiver someValue = 5].
	methodDeterminant1 decision: #returnOne.
	methodDeterminant2 decision: #returnTwo.
	methodDeterminant3 decision: #returnThree.
	
	argumentDeterminant trueDeterminant: receiverDeterminant; falseDeterminant: methodDeterminant3.
	receiverDeterminant trueDeterminant: methodDeterminant1; falseDeterminant: methodDeterminant2.
	
	self register: argumentDeterminant for: #receiverNotRootOfTreeToo:.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:29'!
forceTreeForReceiverNotRootToo
	| methodDeterminant1 methodDeterminant2 methodDeterminant3 receiverDeterminant senderDeterminant |
	receiverDeterminant := ReceiverDeterminant new.
	senderDeterminant := SenderDeterminant new.
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant3 := MethodDeterminant new.
	
	senderDeterminant decision: [:sender | sender myValue < 5].
	receiverDeterminant decision: [:receiver | receiver someValue = 5].
	methodDeterminant1 decision: #returnOne.
	methodDeterminant2 decision: #returnTwo.
	methodDeterminant3 decision: #returnThree.
	
	senderDeterminant trueDeterminant: receiverDeterminant; falseDeterminant: methodDeterminant3.
	receiverDeterminant trueDeterminant: methodDeterminant1; falseDeterminant: methodDeterminant2.
	
	self register: senderDeterminant for: #receiverNotRoot.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:34'!
forceTreeForSenderDeterminant
	| senderDeterminant methodDeterminant2 methodDeterminant1 |
	senderDeterminant := SenderDeterminant new.
	senderDeterminant  decision: [:sender | sender myValue = 5].
	
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant1 decision: #returnOne.
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant2 decision: #returnTwo.
	senderDeterminant trueDeterminant: methodDeterminant1 ; falseDeterminant: methodDeterminant2.
	
	self register: senderDeterminant  for: #senderDeterminant.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:22'!
forceTreeForSenderNotRoot
	| argumentDeterminant methodDeterminant1 methodDeterminant2 methodDeterminant3 senderDeterminant |
	senderDeterminant := SenderDeterminant new.
	argumentDeterminant := ArgumentsDeterminant new.
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant3 := MethodDeterminant new.
	
	argumentDeterminant decision: [:arg | (arg at: 1) < 5].
	senderDeterminant decision: [:sender | sender myValue = 5].
	methodDeterminant1 decision: #returnOne.
	methodDeterminant2 decision: #returnTwo.
	methodDeterminant3 decision: #returnThree.
	
	argumentDeterminant trueDeterminant: senderDeterminant; falseDeterminant: methodDeterminant3.
	senderDeterminant trueDeterminant: methodDeterminant1; falseDeterminant: methodDeterminant2.
	
	self register: argumentDeterminant for: #senderNotRootOfTree:.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:25'!
forceTreeForSenderSender
	| methodDeterminant1 methodDeterminant2 methodDeterminant3 senderDeterminant senderDeterminant2 |
	senderDeterminant := SenderDeterminant new.
	senderDeterminant2 := SenderDeterminant new.
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant3 := MethodDeterminant new.
	
	senderDeterminant decision: [:sender | sender myValue < 5].
	senderDeterminant2 decision: [:sender | sender myValue = 2].
	methodDeterminant1 decision: #returnOne.
	methodDeterminant2 decision: #returnTwo.
	methodDeterminant3 decision: #returnThree.
	
	senderDeterminant trueDeterminant: senderDeterminant2; falseDeterminant: methodDeterminant3.
	senderDeterminant2 trueDeterminant: methodDeterminant1; falseDeterminant: methodDeterminant2.
	
	self register: senderDeterminant for: #senderSenderDeterminant.! !

!MockForceTree methodsFor: 'building' stamp: 'DanielLangone 9/9/2010 15:27'!
forceTreeSenderDeterminant
	| senderDeterminant methodDeterminant2 methodDeterminant1 |
	senderDeterminant := SenderDeterminant new.
	senderDeterminant  decision: [:sender | sender myValue = 5].
	
	methodDeterminant1 := MethodDeterminant new.
	methodDeterminant1 decision: #returnOne.
	methodDeterminant2 := MethodDeterminant new.
	methodDeterminant2 decision: #returnTwo.
	senderDeterminant trueDeterminant: methodDeterminant1 ; falseDeterminant: methodDeterminant2.
	
	self register: senderDeterminant  for: #senderDeterminant.! !

DecisionMetaObject subclass: #PrivateForceTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Private Variable'!

!PrivateForceTree methodsFor: 'building' stamp: 'DanielLangone 10/8/2010 16:05'!
buildPrivateAccessForceTree
	| rightsDeterminant trueMethodDeterminant falseMethodDeterminant |
	rightsDeterminant := MiscDeterminant new.
	
	
	trueMethodDeterminant := InstanceDeterminant new.
	trueMethodDeterminant decision: #privateVariable.
	
	falseMethodDeterminant := MethodDeterminant new.
	falseMethodDeterminant decision:  #noAccess.
	
	rightsDeterminant decision: [:meta| (meta receiver class) = (meta sender class)].
	rightsDeterminant trueDeterminant: trueMethodDeterminant; falseDeterminant: falseMethodDeterminant.
	
	self register: rightsDeterminant for: #privateVariable.! !

!PrivateForceTree methodsFor: 'building' stamp: 'DanielLangone 10/8/2010 16:10'!
buildPrivateManipulateForceTree
	| rightsDeterminant trueMethodDeterminant falseMethodDeterminant |
	rightsDeterminant := MiscDeterminant new.
	
	
	trueMethodDeterminant := InstanceManipulateDeterminant new.
	trueMethodDeterminant decision: #privateVariable.
	
	falseMethodDeterminant := MethodDeterminant new.
	falseMethodDeterminant decision:  #noAccess.
	
	rightsDeterminant decision: [:meta|  (meta receiver class) = (meta sender class)].
	rightsDeterminant trueDeterminant: trueMethodDeterminant; falseDeterminant: falseMethodDeterminant.
	
	self register: rightsDeterminant for: #privateVariable:.! !

DecisionMetaObject subclass: #PrivatePerspective
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Private Variable'!

!PrivatePerspective methodsFor: 'building' stamp: 'DanielLangone 10/18/2010 15:49'!
buildPerspectives
	self register:  (Perspective new) for: #privateVariable.
	self register:  (Perspective new) for: #privateVariable:.! !

DecisionMetaObject subclass: #SourceCodePerspectives
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Group Programming'!

!SourceCodePerspectives methodsFor: 'building' stamp: 'DanielLangone 10/18/2010 14:48'!
buildTree
	self register: (Perspective new) for: #code.
	self register: (Perspective new) for: #addLine:at:.
	self register: (Perspective new) for: #deleteLineAt:.! !

Object subclass: #DecisionStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Core'!

!DecisionStrategy methodsFor: 'decision' stamp: 'DanielLangone 9/10/2010 14:39'!
decideOn: aMessageSendInformation
	self subclassResponsibility.! !

!DecisionStrategy methodsFor: 'updating' stamp: 'DanielLangone 11/5/2010 16:38'!
update: aSubject
	"Will have to be overridden to have some effect."! !

DecisionStrategy subclass: #DecisionStrategyForGroup
	instanceVariableNames: 'forClass subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Moose'!

!DecisionStrategyForGroup methodsFor: 'decision' stamp: 'DanielLangone 11/1/2010 17:26'!
decideOn: aMessageSendInformation
	subject := aMessageSendInformation receiver.
	^(self executeOn: aMessageSendInformation).! !

!DecisionStrategyForGroup methodsFor: 'execution' stamp: 'DanielLangone 10/23/2010 14:59'!
executeOn: aMessageSendInformation
	self subclassResponsibility! !

!DecisionStrategyForGroup methodsFor: 'accessing' stamp: 'DanielLangone 10/23/2010 14:58'!
forClass
	^forClass ! !

!DecisionStrategyForGroup methodsFor: 'accessing' stamp: 'DanielLangone 10/23/2010 14:58'!
forClass: aClass
	forClass := aClass ! !

DecisionStrategyForGroup subclass: #ShowDuplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Moose-FAMIXClass'!

!ShowDuplication methodsFor: 'execution' stamp: 'DanielLangone 11/5/2010 16:44'!
executeOn: aMessageSendInformation
	self error: 'You have no duplications!!'! !

!ShowDuplication methodsFor: 'initialization' stamp: 'DanielLangone 11/2/2010 10:03'!
initialize 
	super initialize.
	forClass := nil. "To not depend on a specific type"! !

!ShowDuplication methodsFor: 'updating' stamp: 'DanielLangone 11/5/2010 16:44'!
update: aSubject
	(((aSubject mooseModel allDuplications) size) > 0)
		ifTrue: [aSubject register: (ViewDuplicationStrategy new) for: #viewDuplication. aSubject viewDuplication.]! !

DecisionStrategyForGroup subclass: #ViewDuplicationStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Moose-FAMIXClass'!

!ViewDuplicationStrategy methodsFor: 'execution' stamp: 'DanielLangone 10/28/2010 14:55'!
executeOn: aMessageSendInformation
| view |
	view := MOViewRenderer new.
	self viewDuplicationComplexityOn: view.
	^ view openWithStatusbar title: 'Duplication Complexity'! !

!ViewDuplicationStrategy methodsFor: 'initialization' stamp: 'DanielLangone 11/1/2010 17:13'!
initialize 
	super initialize.
	forClass := nil. "To not depend on a specific type"! !

!ViewDuplicationStrategy methodsFor: 'updating' stamp: 'DanielLangone 11/5/2010 16:44'!
update: aSubject
	(((aSubject mooseModel allDuplications) size) <= 0)
		ifTrue: [aSubject register: (ShowDuplication new) for: #viewDuplication. aSubject viewDuplication.]! !

!ViewDuplicationStrategy methodsFor: 'additional methods' stamp: 'DanielLangone 11/5/2010 16:23'!
viewDuplication
	<menuItem: 'Subjective Dupliaction complexity' category: 'Visualize'> 
	(self decideOn: thisContext)! !

!ViewDuplicationStrategy methodsFor: 'additional methods' stamp: 'DanielLangone 11/4/2010 10:23'!
viewDuplicationComplexityOn: view 
	subject viewSystemComplexityOn: view.
	view shape curvedLine color: Color red.
	view interaction popupText: [:each | each duplicationText ].
	view 
		edges: subject mooseModel allDuplications 
		from: [:each | each referenceCode entity] 
		to: [:each | each duplicateCode entity].! !

DecisionStrategyForGroup subclass: #ViewSystemComplexitiyOnStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Moose-FAMIXClass'!

!ViewSystemComplexitiyOnStrategy methodsFor: 'execution' stamp: 'DanielLangone 10/28/2010 15:10'!
executeOn: aMessageSendInformation
	self viewSystemComplexityWithSelection: OrderedCollection new on: (aMessageSendInformation arguments at: 1)! !

!ViewSystemComplexitiyOnStrategy methodsFor: 'initialization' stamp: 'DanielLangone 10/28/2010 15:08'!
initialize 
	super initialize.
	forClass := FAMIXClass.! !

!ViewSystemComplexitiyOnStrategy methodsFor: 'additional methods' stamp: 'DanielLangone 10/28/2010 15:09'!
viewSystemComplexityWithSelection: selectedClassGroup height: heightBlock width: widthBlock color: colorBlock on: view
	| rootClasses lonelyRootClasses shape |
	shape := (MORectangleShape new 
				height: heightBlock;
				width: widthBlock;
				linearFillColor: colorBlock within: subject;
				borderWidth: [:x | (selectedClassGroup includes: x) ifTrue: [3] ifFalse: [1]];
				borderColor: [:x | (selectedClassGroup includes: x) ifTrue: [Color red] ifFalse: [Color black]]
				).
	rootClasses := subject select: [:each | each isHierarchyRootWithin: subject].
	lonelyRootClasses := rootClasses select: [:each | each isLonelyWithin: subject].
	rootClasses := rootClasses difference: lonelyRootClasses.
	rootClasses notEmpty ifTrue: [
		view shape rectangle withoutBorder.
		view node: rootClasses forIt: [
			rootClasses do: [:each | 
				view shape rectangle withoutBorder.
				view interaction popupText: [:group | 'Subhierarchy of ', group first printString ].
				view interaction menuMorphBlock: [ :group | group mooseMenuMorph ].
				view node: each withSubclassHierarchyGroup forIt: [
					view interaction popupView: [ :entity :popupView | 
						entity viewBlueprintOn: popupView ] zoomedInBy: 0.5.
					view interaction menuMorphBlock: [ :eachClass | eachClass mooseMenuMorph ].
					view nodes: each withSubclassHierarchy using: shape.
					view edgesFrom: #superclass.
					view treeLayout topGap: 0; leftGap: 0.
				].
			].
			view shape line color: Color lightGray.
			view flowLayout maxWidth: 600.
		] 
	].
	lonelyRootClasses notEmpty ifTrue: [
		view shape rectangle withoutBorder.
		view interaction menuMorphBlock: [ :each | each mooseMenuMorph ].
		view interaction popupText: [:group | 'Lonely classes' ].
		view node: lonelyRootClasses forIt: [
			view interaction popupView: [:entity :popupView | entity viewBlueprintOn: popupView].
			view interaction menuMorphBlock: [ :each | each mooseMenuMorph ].
			view nodes: (lonelyRootClasses sorted: [:a :b | a numberOfMethods < b numberOfMethods ] ) using: shape.
			view flowLayout maxWidth: 300; gapSize: 2.
		].
	]! !

!ViewSystemComplexitiyOnStrategy methodsFor: 'additional methods' stamp: 'DanielLangone 10/28/2010 15:09'!
viewSystemComplexityWithSelection: selectedClassGroup on: view
	^ self 
		viewSystemComplexityWithSelection: selectedClassGroup 
		height: #numberOfMethods 
		width: #numberOfAttributes
		color: #numberOfLinesOfCode on: view! !

DecisionStrategyForGroup subclass: #ViewSystemComplexitiyStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Moose-FAMIXClass'!

!ViewSystemComplexitiyStrategy methodsFor: 'execution' stamp: 'DanielLangone 10/28/2010 15:10'!
executeOn: aMessageSendInformation
	| view |
	subject := aMessageSendInformation receiver.
	view := MOViewRenderer new.
	subject viewSystemComplexityOn: view.
	^ view openWithStatusbar title: 'System Complexity'! !

!ViewSystemComplexitiyStrategy methodsFor: 'initialize-release' stamp: 'DanielLangone 10/23/2010 15:48'!
initialize 
	super initialize.
	forClass := FAMIXClass.! !

!ViewSystemComplexitiyStrategy methodsFor: 'additional methods' stamp: 'DanielLangone 11/5/2010 13:20'!
viewSystemComplexity
	<menuItem: 'Subjective System complexity' category: 'Visualize'> 
	(self decideOn: thisContext)! !

DecisionStrategy subclass: #ForceTreeNode
	instanceVariableNames: 'decision'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree'!

ForceTreeNode subclass: #ForceDeterminant
	instanceVariableNames: 'trueDeterminant falseDeterminant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree'!

ForceDeterminant subclass: #AquintanceDeterminant
	instanceVariableNames: 'classDecision identity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree'!

!AquintanceDeterminant methodsFor: 'setting' stamp: 'DanielLangone 9/3/2010 14:45'!
classDecision: aClass
	classDecision := aClass.! !

!AquintanceDeterminant methodsFor: 'decision' stamp: 'DanielLangone 9/9/2010 14:47'!
decideOn: aMessageSendInformation
	| aquintanceObject |
	aquintanceObject := (classDecision allInstances) select: [:object | (object instVarNamed: identity) = (aMessageSendInformation identityInstVar)].
	^((self returnDeterminantFor: (decision value: (aquintanceObject at: 1) value: aMessageSendInformation)) decideOn: aMessageSendInformation).! !

!AquintanceDeterminant methodsFor: 'setting' stamp: 'DanielLangone 9/4/2010 12:30'!
identity: aBinaryString
	identity := aBinaryString.! !

!AquintanceDeterminant methodsFor: 'initialize-release' stamp: 'DanielLangone 9/3/2010 14:51'!
initialize 
	super initialize.
	classDecision := Object.
	identity := #a.! !

ForceDeterminant subclass: #ArgumentsDeterminant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree'!

!ArgumentsDeterminant methodsFor: 'decision' stamp: 'DanielLangone 9/9/2010 14:47'!
decideOn: aMessageSendInformation
	^((self returnDeterminantFor: (decision value: aMessageSendInformation arguments)) decideOn: aMessageSendInformation).! !

!ForceDeterminant methodsFor: 'decision' stamp: 'DanielLangone 9/9/2010 14:46'!
decideOn: aMessageSendInformation
	self subclassResponsibility! !

!ForceDeterminant methodsFor: 'execution' stamp: 'DanielLangone 9/9/2010 13:31'!
executeOn: aSubject with:  anArray
	self error: 'Should not be called.'! !

!ForceDeterminant methodsFor: 'setting' stamp: 'DanielLangone 8/19/2010 11:25'!
falseDeterminant: aBlock
	falseDeterminant := aBlock.! !

!ForceDeterminant methodsFor: 'setting' stamp: 'DanielLangone 9/9/2010 11:50'!
returnDeterminantFor: aBoolean
	^(aBoolean ifTrue: [trueDeterminant ] ifFalse: [falseDeterminant ])! !

!ForceDeterminant methodsFor: 'setting' stamp: 'DanielLangone 8/19/2010 11:25'!
trueDeterminant: aBlock
	trueDeterminant := aBlock.! !

ForceDeterminant subclass: #MiscDeterminant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree'!

!MiscDeterminant methodsFor: 'decision' stamp: 'DanielLangone 9/9/2010 14:47'!
decideOn: aMessageSendInformation
	^((self returnDeterminantFor: (decision value: aMessageSendInformation)) decideOn: aMessageSendInformation).! !

ForceDeterminant subclass: #ReceiverDeterminant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree'!

!ReceiverDeterminant methodsFor: 'decision' stamp: 'DanielLangone 9/9/2010 14:48'!
decideOn: aMessageSendInformation
	^((self returnDeterminantFor: (decision value: aMessageSendInformation receiver)) decideOn: aMessageSendInformation).! !

ForceDeterminant subclass: #SenderDeterminant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree'!

!SenderDeterminant methodsFor: 'decision' stamp: 'DanielLangone 9/9/2010 14:48'!
decideOn: aMessageSendInformation
	^((self returnDeterminantFor: (decision value: aMessageSendInformation sender)) decideOn: aMessageSendInformation).! !

!ForceTreeNode methodsFor: 'decision' stamp: 'DanielLangone 10/8/2010 15:58'!
decideOn: aMessageSendInformation
	^self executeOn: (aMessageSendInformation receiver) with: (aMessageSendInformation arguments asArray).! !

!ForceTreeNode methodsFor: 'decision' stamp: 'DanielLangone 9/6/2010 14:41'!
decision: aBlockOrBinaryString
	decision := aBlockOrBinaryString.! !

!ForceTreeNode methodsFor: 'execution' stamp: 'DanielLangone 9/9/2010 13:30'!
executeOn: aSubject with: anArray
	self subclassResponsibility.! !

ForceTreeNode subclass: #InstanceDeterminant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree'!

!InstanceDeterminant methodsFor: 'execution' stamp: 'DanielLangone 10/8/2010 15:59'!
executeOn: aSubject with:  anArray
	^((aSubject) instVarNamed: decision)! !

ForceTreeNode subclass: #InstanceManipulateDeterminant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree'!

!InstanceManipulateDeterminant methodsFor: 'execution' stamp: 'DanielLangone 10/8/2010 15:59'!
executeOn: aSubject with:  anArray
	((aSubject) instVarNamed: decision put: (anArray at: 1))! !

ForceTreeNode subclass: #MethodDeterminant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree'!

!MethodDeterminant methodsFor: 'execution' stamp: 'DanielLangone 9/9/2010 13:31'!
executeOn: aSubject with:  anArray
	^((aSubject) run: decision with: anArray)! !

DecisionStrategy subclass: #MockDecisionStrategy
	instanceVariableNames: 'messageInformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Core-Tests'!

!MockDecisionStrategy methodsFor: 'decision' stamp: 'DanielLangone 10/15/2010 14:20'!
decideOn: aMessageSendInformation
	messageInformation := aMessageSendInformation.
	^1! !

!MockDecisionStrategy methodsFor: 'accessing' stamp: 'DanielLangone 10/15/2010 14:19'!
messageInformation
	^messageInformation.! !

DecisionStrategy subclass: #MockDecisionStrategyForContextualElement
	instanceVariableNames: 'messageInformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Core-Tests'!

!MockDecisionStrategyForContextualElement methodsFor: 'decision' stamp: 'DanielLangone 10/15/2010 14:45'!
decideOn: aMessageSendInformation
	messageInformation := aMessageSendInformation.
	^((aMessageSendInformation contextualElement) decideOn: aMessageSendInformation)! !

!MockDecisionStrategyForContextualElement methodsFor: 'accessing' stamp: 'DanielLangone 10/15/2010 14:49'!
messageInformation
	^messageInformation.! !

DecisionStrategy subclass: #Perspective
	instanceVariableNames: 'rootLayer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Perspective'!

!Perspective methodsFor: 'decision' stamp: 'DanielLangone 10/18/2010 11:04'!
decideOn: aMessageSendInformation
	^((aMessageSendInformation contextualElement) decideOn: aMessageSendInformation)! !

DecisionStrategy subclass: #RoleDictionary
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Role'!

RoleDictionary subclass: #BankAccountRolesDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-BankAccount'!

!BankAccountRolesDictionary methodsFor: 'building' stamp: 'DanielLangone 10/12/2010 09:37'!
buildRoles
	| bankrole |
	bankrole := BankRole new.
	bankrole child: (UserRole new).
	self register:  bankrole for: #private.
	self register:  (bankrole child) for: #user.! !

RoleDictionary subclass: #MailDelivererRolesDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!MailDelivererRolesDictionary methodsFor: 'building' stamp: 'DanielLangone 10/18/2010 16:41'!
authorizedPerspective
	self register:  (AuthorizationRole new) for: #authorized.
	self register:  (Role new) for: #notAuthorized.! !

RoleDictionary subclass: #PrivateRoleDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Private Variable'!

!PrivateRoleDictionary methodsFor: 'building' stamp: 'DanielLangone 10/14/2010 11:22'!
buildRole
	self register:  (PrivateRole new) for: #private.! !

!RoleDictionary methodsFor: 'building' stamp: 'DanielLangone 10/18/2010 16:36'!
buildDictionary
	((self class = RoleDictionary) not) ifTrue: [
		self class methods do: [:each | ((each numArgs = 0) and: [(each selector = 'initialize') not]) ifTrue: [each valueWithReceiver: self arguments: #()]]
	]! !

!RoleDictionary methodsFor: 'decision' stamp: 'DanielLangone 10/19/2010 09:12'!
decideOn: aMessageSendInformation
| role |
	[role := (dictionary at: (aMessageSendInformation contextualElement))] on: Error do: [role := nil].
	^((role isNil) ifTrue: [
			(aMessageSendInformation receiver) run: (aMessageSendInformation selector) with: (aMessageSendInformation arguments)
		]
		ifFalse: [
			role decideOn: aMessageSendInformation.
		])! !

!RoleDictionary methodsFor: 'building' stamp: 'DanielLangone 10/19/2010 09:23'!
generateDecisionMetaObject
	|aDecisionMetaObject methodNames|
	methodNames := OrderedCollection new.
	aDecisionMetaObject := DecisionMetaObject new.
	dictionary valuesDo: [:each | (each instVarNamed: #roleMethodDictionary) keysDo: [:key | methodNames add: key]].
	methodNames do: [:methodName | aDecisionMetaObject register: self for: methodName].
	^aDecisionMetaObject! !

!RoleDictionary methodsFor: 'initialization' stamp: 'DanielLangone 10/18/2010 16:35'!
initialize 
	super initialize.
	dictionary := Dictionary new.
	self buildDictionary.! !

!RoleDictionary methodsFor: 'register' stamp: 'DanielLangone 10/18/2010 16:05'!
register: aRole for: aBinaryString
	dictionary at: aBinaryString put: aRole.! !

Object subclass: #Device
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!Device methodsFor: 'accessing' stamp: 'DanielLangone 8/31/2010 11:27'!
owner
	^owner! !

!Device methodsFor: 'setting' stamp: 'DanielLangone 8/31/2010 11:26'!
owner: aUser
	owner := aUser.! !

Object subclass: #Mail
	instanceVariableNames: 'recipient sender message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!Mail methodsFor: 'accessing' stamp: 'DanielLangone 8/31/2010 11:22'!
message
	^message! !

!Mail methodsFor: 'setting' stamp: 'DanielLangone 8/31/2010 11:23'!
message: aString
	message := aString! !

!Mail methodsFor: 'accessing' stamp: 'DanielLangone 8/31/2010 11:23'!
recipient
	^recipient! !

!Mail methodsFor: 'setting' stamp: 'DanielLangone 9/4/2010 12:41'!
recipient: aString
	recipient := aString.! !

!Mail methodsFor: 'accessing' stamp: 'DanielLangone 8/31/2010 11:23'!
sender
	^sender! !

!Mail methodsFor: 'setting' stamp: 'DanielLangone 9/4/2010 12:41'!
sender: aString
	sender := aString! !

Object subclass: #MessageSendInformation
	instanceVariableNames: 'receiver sender arguments selector identityInstVar contextualElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Core'!

!MessageSendInformation methodsFor: 'accessing' stamp: 'DanielLangone 10/15/2010 13:21'!
arguments
	^(arguments asArray)! !

!MessageSendInformation methodsFor: 'setting' stamp: 'DanielLangone 9/9/2010 14:44'!
arguments: anArray
	(anArray isNil) 
		ifTrue: [arguments := OrderedCollection new] 
		ifFalse:[arguments := anArray]! !

!MessageSendInformation methodsFor: 'accessing' stamp: 'DanielLangone 10/15/2010 13:20'!
contextualElement
	^contextualElement! !

!MessageSendInformation methodsFor: 'setting' stamp: 'DanielLangone 10/15/2010 13:20'!
contextualElement: aContextualElement
	contextualElement := aContextualElement.! !

!MessageSendInformation methodsFor: 'accessing' stamp: 'DanielLangone 9/4/2010 12:26'!
identityInstVar
	^identityInstVar.! !

!MessageSendInformation methodsFor: 'setting' stamp: 'DanielLangone 9/4/2010 12:26'!
identityInstVar: anObject
	identityInstVar := anObject.! !

!MessageSendInformation methodsFor: 'initialize-release' stamp: 'daniellangone 8/17/2010 16:47'!
initialize 
	arguments := OrderedCollection new.! !

!MessageSendInformation methodsFor: 'accessing' stamp: 'DanielLangone 10/15/2010 13:22'!
receiver
	^receiver ! !

!MessageSendInformation methodsFor: 'setting' stamp: 'DanielLangone 10/15/2010 13:22'!
receiver: aSubject
	receiver := aSubject.! !

!MessageSendInformation methodsFor: 'accessing' stamp: 'DanielLangone 10/15/2010 13:23'!
selector
	^selector! !

!MessageSendInformation methodsFor: 'setting' stamp: 'DanielLangone 10/15/2010 13:23'!
selector: aBinaryString
	selector := aBinaryString.! !

!MessageSendInformation methodsFor: 'accessing' stamp: 'daniellangone 8/17/2010 16:17'!
sender
	^sender ! !

!MessageSendInformation methodsFor: 'setting' stamp: 'daniellangone 8/17/2010 16:17'!
sender: anObject
	sender := anObject.! !

Object subclass: #MockObject
	instanceVariableNames: 'id myValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree-Tests'!

!MockObject methodsFor: 'testMethods' stamp: 'DanielLangone 9/9/2010 15:21'!
argumentNotRootOfTree: aSubject withArg: anInteger
	^(aSubject argumentNotRootOfTree: anInteger)! !

!MockObject methodsFor: 'testMethods' stamp: 'DanielLangone 9/9/2010 15:05'!
complexFor: aSubject withArg: anInteger
	^(aSubject complexMessage: anInteger)! !

!MockObject methodsFor: 'setting' stamp: 'DanielLangone 9/3/2010 15:17'!
id: anInteger
	id := anInteger.! !

!MockObject methodsFor: 'initialize-release' stamp: 'DanielLangone 9/3/2010 16:00'!
initialize 
	myValue := 1.
	id := 1.! !

!MockObject methodsFor: 'accessing' stamp: 'DanielLangone 8/19/2010 11:57'!
myValue 
	^myValue ! !

!MockObject methodsFor: 'setting' stamp: 'DanielLangone 8/19/2010 11:57'!
myValue: anInteger
	myValue :=anInteger .! !

!MockObject methodsFor: 'testMethods' stamp: 'DanielLangone 9/9/2010 15:29'!
receiverNotRootOfTree: aSubject
	^(aSubject receiverNotRoot)! !

!MockObject methodsFor: 'testMethods' stamp: 'DanielLangone 9/9/2010 15:23'!
receiverNotRootOfTreeToo: aSubject withArg: anInteger
	^(aSubject receiverNotRootOfTreeToo: anInteger)! !

!MockObject methodsFor: 'testMethods' stamp: 'DanielLangone 9/9/2010 15:27'!
senderDeterminant: aSubject
	^(aSubject senderDeterminant)! !

!MockObject methodsFor: 'testMethods' stamp: 'DanielLangone 9/9/2010 15:22'!
senderNotRootOfTree: aSubject withArg: anInteger
	^(aSubject senderNotRootOfTree: anInteger)! !

!MockObject methodsFor: 'testMethods' stamp: 'DanielLangone 9/9/2010 15:28'!
senderSenderDeterminant: aSubject
	^(aSubject senderSenderDeterminant)! !

Object subclass: #ObjectExtensions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Moose'!

!ObjectExtensions methodsFor: 'changed methods' stamp: 'DanielLangone 11/5/2010 16:43'!
mooseFinderActions
	| categorized simple all first second all2 classes tmp |
	"BEGIN ADDED -- To walk also through decision meta object"
	(self decisionMetaObject isNil not) ifTrue: [self update].
	all2 := (self decisionMetaObject isNil not) ifTrue: [
		classes := self decisionMetaObject collectValues: [:each | each class].
		
		tmp := classes flatCollect: [:eachClass |
		categorized := (Pragma allNamed: #menuItem:category: in: eachClass) collect: [:eachPragma |
				GLMAction new 
					action: [:x | self perform: eachPragma selector ];
					title: (eachPragma argumentAt: 1);
					category: (eachPragma argumentAt: 2) ].
				simple := (Pragma allNamed: #menuItem: in: eachClass) collect: [:eachPragma |
				GLMAction new 
					action: [:x | self perform: eachPragma selector ];
					title: (eachPragma argumentAt: 1) ].
		categorized, simple].
	tmp.
		
		] ifFalse: [SortedCollection new.].
	"End ADDED"
	all := self class withAllSuperclasses flatCollect: [:eachClass |
		categorized := (Pragma allNamed: #menuItem:category: in: eachClass) collect: [:eachPragma |
				GLMAction new 
					action: [:x | self perform: eachPragma selector ];
					title: (eachPragma argumentAt: 1);
					category: (eachPragma argumentAt: 2) ].
		simple := (Pragma allNamed: #menuItem: in: eachClass) collect: [:eachPragma |
				GLMAction new 
					action: [:x | self perform: eachPragma selector ];
					title: (eachPragma argumentAt: 1) ].
		categorized, simple].
	"BEGIN ADDED"
	all addAll: all2.
	"END ADDED"
	
	^ all asSortedCollection: [:a :b | 
		first := a isCategorized ifTrue: [a category, a title] ifFalse: [a title].
		second := b isCategorized ifTrue: [b category, b title] ifFalse: [b title].
		first < second]! !

Object subclass: #Room
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!Room methodsFor: 'comparing' stamp: 'DanielLangone 9/4/2010 13:55'!
= aRoom
	^((aRoom class = Room) and: [aRoom name = self name]).! !

!Room methodsFor: 'accessing' stamp: 'DanielLangone 9/4/2010 13:54'!
name
	^name! !

!Room methodsFor: 'setting' stamp: 'DanielLangone 9/4/2010 13:54'!
name: aString
	name := aString ! !

!Room methodsFor: 'print' stamp: 'DanielLangone 9/6/2010 16:33'!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."

	super printOn: aStream.
	 aStream
		nextPutAll: ': ';
		nextPutAll: (self name)! !

Object subclass: #Subject
	instanceVariableNames: 'decisionMetaObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Core'!

Subject subclass: #BankAccount
	instanceVariableNames: 'balance bankName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-BankAccount'!

!BankAccount methodsFor: 'initialize-release' stamp: 'DanielLangone 10/15/2010 16:16'!
initialize 
	super initialize.
	balance := 0.
	bankName := 'Normal Bank'.! !

!BankAccount methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 11:10'!
notAuthorized
	self error: 'You are not authorized to perform this action.'! !

!BankAccount methodsFor: 'testing' stamp: 'DanielLangone 10/18/2010 11:10'!
notEnoughMoney 
	self error: 'You have not enough money to do the transfer'! !

!BankAccount methodsFor: 'transfer' stamp: 'DanielLangone 10/18/2010 11:31'!
realTransfer: anInteger to: aBankaccount
	aBankaccount balance: (aBankaccount balance + anInteger).
	balance := balance - anInteger.! !

Subject subclass: #MailDeliverer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

!MailDeliverer methodsFor: 'deliver' stamp: 'DanielLangone 8/31/2010 13:58'!
authorizationFailure
	self error: 'Could not send mail, because you are not authorized to!!'.! !

!MailDeliverer methodsFor: 'deliver' stamp: 'DanielLangone 10/15/2010 16:14'!
deliverFast
	^2! !

!MailDeliverer methodsFor: 'deliver' stamp: 'DanielLangone 9/4/2010 12:38'!
deliverNormal
	^1! !

!MailDeliverer methodsFor: 'deliver' stamp: 'DanielLangone 10/8/2010 11:28'!
deliverPerspective: aMail
	self error: 'You are not authorized to send mails!!'! !

!MailDeliverer methodsFor: 'deliver' stamp: 'DanielLangone 10/18/2010 16:26'!
perspectivefor: aUser
	^((aUser = (aUser device owner)) 
		ifTrue: [
			AuthorizationLayer new
		] 
		ifFalse: [
			PerspectiveLayer new
		]).! !

!MailDeliverer methodsFor: 'deliver' stamp: 'DanielLangone 10/18/2010 16:41'!
rolefor: aUser
	^((aUser = (aUser device owner)) 
		ifTrue: [
			#authorized
		] 
		ifFalse: [
			#notAuthorized
		]).! !

Subject subclass: #MockForceTreeSubject
	instanceVariableNames: 'someValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-ForceTree-Tests'!

!MockForceTreeSubject methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:21'!
returnFive
	^5! !

!MockForceTreeSubject methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:21'!
returnFour
	^4! !

!MockForceTreeSubject methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:16'!
returnOne
	^1! !

!MockForceTreeSubject methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:19'!
returnPlusOne: anInteger
	^(anInteger+1)! !

!MockForceTreeSubject methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:18'!
returnPlusTwo: anInteger
	^(anInteger+2)! !

!MockForceTreeSubject methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:17'!
returnThree
	^3! !

!MockForceTreeSubject methodsFor: 'testing' stamp: 'DanielLangone 10/15/2010 15:17'!
returnTwo
	^2! !

!MockForceTreeSubject methodsFor: 'setting' stamp: 'DanielLangone 10/15/2010 15:20'!
someValue
	^someValue! !

!MockForceTreeSubject methodsFor: 'setting' stamp: 'DanielLangone 10/15/2010 15:20'!
someValue: anObject
	someValue := anObject! !

Subject subclass: #PerspectiveSubject
	instanceVariableNames: 'someVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Perspective-Tests'!

!PerspectiveSubject methodsFor: 'initialize-release' stamp: 'DanielLangone 10/18/2010 09:29'!
initialize 
	super initialize.
	someVariable := 5.! !

!PerspectiveSubject methodsFor: 'testMethods' stamp: 'DanielLangone 10/8/2010 09:51'!
test
	^ 2! !

Subject subclass: #PrivateSubject
	instanceVariableNames: 'privateVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Private Variable'!

!PrivateSubject methodsFor: 'forceTree methods' stamp: 'DanielLangone 10/18/2010 15:55'!
accessPrivateVariableOf: aSubject
	^(aSubject privateVariable)! !

!PrivateSubject methodsFor: 'forceTree methods' stamp: 'DanielLangone 10/18/2010 15:56'!
changePrivateVariableOf: aSubject to: anObject
	aSubject privateVariable: anObject! !

!PrivateSubject methodsFor: 'initialize-release' stamp: 'DanielLangone 10/18/2010 09:27'!
initialize 
	super initialize.
	privateVariable := 1.
	! !

!PrivateSubject methodsFor: 'forceTree methods' stamp: 'DanielLangone 10/8/2010 15:55'!
noAccess
	self error: 'You have no right to access this variable'! !

Subject subclass: #RoleSubject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Role-Tests'!

!RoleSubject methodsFor: 'initialize-release' stamp: 'DanielLangone 10/18/2010 15:57'!
initialize 
	super initialize.
	! !

!RoleSubject methodsFor: 'test methods' stamp: 'DanielLangone 10/11/2010 14:11'!
test
	^1! !

!RoleSubject methodsFor: 'test methods' stamp: 'DanielLangone 10/18/2010 17:05'!
test3
	^4! !

Subject subclass: #RootSubject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Core-Tests'!

RootSubject subclass: #ChildSubject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Core-Tests'!

!ChildSubject methodsFor: 'testing' stamp: 'DanielLangone 10/23/2010 12:39'!
test
	^(self decideOn: thisContext)! !

!RootSubject methodsFor: 'testing' stamp: 'DanielLangone 10/23/2010 12:38'!
test
	^3! !

Subject subclass: #SourceCode
	instanceVariableNames: 'codeAsArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Group Programming'!

!SourceCode methodsFor: 'manipulating' stamp: 'DanielLangone 10/18/2010 14:30'!
addLine: aString at: anInteger
	self error: 'You should not directly manipulate the SourceCode object.'! !

!SourceCode methodsFor: 'converting' stamp: 'DanielLangone 10/5/2010 16:21'!
asOrderedCollection
	^codeAsArray copy ! !

!SourceCode methodsFor: 'converting' stamp: 'DanielLangone 10/5/2010 15:47'!
asText
	|text|
	codeAsArray do: 
		[:el | (text isNil) 
			ifTrue: [text := el] 
			ifFalse: [text := text, String cr, el]
		].
	^((text isNil) ifTrue: [''] ifFalse: [text])! !

!SourceCode methodsFor: 'setting' stamp: 'DanielLangone 10/5/2010 16:18'!
code: anOrderedCollection
	codeAsArray :=anOrderedCollection! !

!SourceCode methodsFor: 'manipulating' stamp: 'DanielLangone 10/18/2010 14:48'!
deleteLineAt: anInteger
	self error: 'You should not directly manipulate the SourceCode object.'! !

!SourceCode methodsFor: 'initialize-release' stamp: 'DanielLangone 10/18/2010 11:34'!
initialize 
	super initialize.
	codeAsArray := OrderedCollection new.
! !

!SourceCode methodsFor: 'print' stamp: 'DanielLangone 10/5/2010 16:09'!
printOn: aStream
	super printOn: aStream.
	codeAsArray printOn: aStream.! !

!Subject class methodsFor: 'instance creation' stamp: 'DanielLangone 10/15/2010 14:07'!
decisionMetaObject: aDecisionMetaObject
	^(self basicNew decisionMetaObject: aDecisionMetaObject).! !

!Subject methodsFor: 'decision' stamp: 'DanielLangone 10/23/2010 12:15'!
decideOn: aContext
	^ (self decideOn: aContext withIdentity: nil)! !

!Subject methodsFor: 'decision' stamp: 'DanielLangone 10/8/2010 10:05'!
decideOn: aContext withIdentity: anObject
	^ (decisionMetaObject for: self context: aContext withIdentity: anObject)! !

!Subject methodsFor: 'accessing' stamp: 'DanielLangone 11/5/2010 13:00'!
decisionMetaObject
	^decisionMetaObject! !

!Subject methodsFor: 'setting' stamp: 'daniellangone 8/17/2010 15:58'!
decisionMetaObject: aDecisionMetaObject
	decisionMetaObject := aDecisionMetaObject.! !

!Subject methodsFor: 'error handling' stamp: 'DanielLangone 10/15/2010 13:54'!
doesNotUnderstand: aMessage

	^(((decisionMetaObject isNil) not) and: [decisionMetaObject exists: (aMessage)])
		ifTrue: [
			decisionMetaObject decideOn: aMessage with: thisContext from: self. 
		]
		ifFalse: [
			super doesNotUnderstand: aMessage.
		].! !

!Subject methodsFor: 'initialize-release' stamp: 'DanielLangone 10/23/2010 15:29'!
initialize 
	self decisionMetaObject: (DecisionMetaObject new).! !

!Subject methodsFor: 'register' stamp: 'DanielLangone 11/2/2010 10:08'!
register: aDecisionStrategy for: aSymbol
	(decisionMetaObject isNil) ifTrue: [decisionMetaObject := DecisionMetaObject new].
	decisionMetaObject register: aDecisionStrategy for: aSymbol ! !

!Subject methodsFor: 'running' stamp: 'DanielLangone 10/11/2010 15:28'!
run: aBinaryString with: anArray
	| method |
	method := (self class lookupSelector: (aBinaryString)).
	^(method isNil) ifFalse: [(((self class methodDictionary at: (aBinaryString)) numArgs) = 0) 
		ifTrue: [
			(self executeMethod: (self class methodDictionary at: (aBinaryString)))
		]
		ifFalse: [
			(self withArgs: (anArray) executeMethod: (self class methodDictionary at: (aBinaryString)))
		].]
	ifTrue: [self error: self class asString, ' does not understand: ', aBinaryString asString]! !

!Subject methodsFor: 'updating' stamp: 'DanielLangone 11/5/2010 16:38'!
update
	decisionMetaObject update: self.! !

Object subclass: #Subjectopia
	instanceVariableNames: 'decisionMetaObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-Moose-Setup'!

Subjectopia class
	instanceVariableNames: 'temporaryMethodDictionaryMooseGroup temporaryClassMethodDictionaryObject temporaryMethodDictionaryMooseAbstractGroup temporaryClassMethodDictionaryMooseGroup temporaryClassMethodDictionaryMooseAbstractGroup viewSystemComplexityMethod viewDuplicationMethod state temporaryMethodDictionaryObject'!

!Subjectopia commentStamp: '<historical>' prior: 0!
In order to start Moose in Subjectivity Mode use:
	Setup start
In order to end Moose in Subjectivity Mode use:
	Setup  stop!

Subjectopia class
	instanceVariableNames: 'temporaryMethodDictionaryMooseGroup temporaryClassMethodDictionaryObject temporaryMethodDictionaryMooseAbstractGroup temporaryClassMethodDictionaryMooseGroup temporaryClassMethodDictionaryMooseAbstractGroup viewSystemComplexityMethod viewDuplicationMethod state temporaryMethodDictionaryObject'!

!Subjectopia class methodsFor: 'testing' stamp: 'DanielLangone 11/4/2010 09:40'!
isObjective
	^((state isNil) or: [state = 0])! !

!Subjectopia class methodsFor: 'testing' stamp: 'DanielLangone 11/4/2010 09:37'!
isSubjective
	^(self isObjective not)! !

!Subjectopia class methodsFor: 'initialize-release' stamp: 'DanielLangone 11/4/2010 09:39'!
start
	^(self basicNew start)! !

!Subjectopia class methodsFor: 'setting' stamp: 'DanielLangone 11/4/2010 09:39'!
state: anInteger
	state := anInteger! !

!Subjectopia class methodsFor: 'initialize-release' stamp: 'DanielLangone 10/25/2010 15:39'!
stop
	^(self basicNew stop)! !

!Subjectopia class methodsFor: 'class methods' stamp: 'DanielLangone 11/1/2010 16:11'!
temporaryClassMethodDictionaryMooseAbstractGroup
	^temporaryClassMethodDictionaryMooseAbstractGroup! !

!Subjectopia class methodsFor: 'class methods' stamp: 'DanielLangone 11/1/2010 16:11'!
temporaryClassMethodDictionaryMooseAbstractGroup: aDictionary
	temporaryClassMethodDictionaryMooseAbstractGroup := aDictionary ! !

!Subjectopia class methodsFor: 'class methods' stamp: 'DanielLangone 11/1/2010 16:11'!
temporaryClassMethodDictionaryMooseGroup
	^temporaryClassMethodDictionaryMooseGroup ! !

!Subjectopia class methodsFor: 'class methods' stamp: 'DanielLangone 11/1/2010 16:11'!
temporaryClassMethodDictionaryMooseGroup: aDictionary
	temporaryClassMethodDictionaryMooseGroup := aDictionary ! !

!Subjectopia class methodsFor: 'class methods' stamp: 'DanielLangone 11/5/2010 11:15'!
temporaryClassMethodDictionaryObject
	^temporaryClassMethodDictionaryObject ! !

!Subjectopia class methodsFor: 'class methods' stamp: 'DanielLangone 11/5/2010 11:15'!
temporaryClassMethodDictionaryObject: aDictionary
	temporaryClassMethodDictionaryObject := aDictionary! !

!Subjectopia class methodsFor: 'objects methods' stamp: 'DanielLangone 11/1/2010 16:11'!
temporaryMethodDictionaryMooseAbstractGroup
	^temporaryMethodDictionaryMooseAbstractGroup ! !

!Subjectopia class methodsFor: 'objects methods' stamp: 'DanielLangone 11/1/2010 16:11'!
temporaryMethodDictionaryMooseAbstractGroup: aDictionary
	temporaryMethodDictionaryMooseAbstractGroup := aDictionary ! !

!Subjectopia class methodsFor: 'objects methods' stamp: 'DanielLangone 11/1/2010 16:11'!
temporaryMethodDictionaryMooseGroup
	^temporaryMethodDictionaryMooseGroup ! !

!Subjectopia class methodsFor: 'objects methods' stamp: 'DanielLangone 11/1/2010 16:12'!
temporaryMethodDictionaryMooseGroup: aDictionary
	temporaryMethodDictionaryMooseGroup := aDictionary ! !

!Subjectopia class methodsFor: 'objects methods' stamp: 'DanielLangone 11/5/2010 11:16'!
temporaryMethodDictionaryObject
	^temporaryMethodDictionaryObject! !

!Subjectopia class methodsFor: 'objects methods' stamp: 'DanielLangone 11/5/2010 11:16'!
temporaryMethodDictionaryObject: aDictionary
	temporaryMethodDictionaryObject := aDictionary! !

!Subjectopia class methodsFor: 'single methods' stamp: 'DanielLangone 10/28/2010 14:44'!
viewDuplicationMethod
	^viewDuplicationMethod ! !

!Subjectopia class methodsFor: 'single methods' stamp: 'DanielLangone 10/28/2010 14:44'!
viewDuplicationMethod: aCompiledMethod
	viewDuplicationMethod := aCompiledMethod! !

!Subjectopia class methodsFor: 'single methods' stamp: 'DanielLangone 10/25/2010 15:41'!
viewSystemComplexityMethod
	^viewSystemComplexityMethod ! !

!Subjectopia class methodsFor: 'single methods' stamp: 'DanielLangone 10/25/2010 15:42'!
viewSystemComplexityMethod: aCompiledMethod
	viewSystemComplexityMethod := aCompiledMethod! !

!Subjectopia methodsFor: 'initialize-release' stamp: 'DanielLangone 2/10/2011 14:04'!
initialize 
	"state = 0."! !

!Subjectopia methodsFor: 'override methods' stamp: 'DanielLangone 2/10/2011 13:48'!
overrideDictionaryFrom: aClass to: aSubjectiveClass
	| tempMethod temporaryMethodDictionary aDictionary |
	
	temporaryMethodDictionary := Dictionary new.
	aDictionary := aSubjectiveClass methodDictionary.
	((aDictionary isNil not) and: [Subjectopia isObjective]) 
		ifTrue: [
			aDictionary keysDo: [:key | [tempMethod := aClass methodDictionary at: key. temporaryMethodDictionary at: key put: tempMethod] on: Error do: [temporaryMethodDictionary at: key put: nil]].
			aDictionary keysDo: [:key | aClass methodDictionary at: key put: (aSubjectiveClass methodDictionary at: key).].].
	
	^temporaryMethodDictionary.
	
! !

!Subjectopia methodsFor: 'override methods' stamp: 'DanielLangone 2/10/2011 13:48'!
overrideFamixMethods
	(Subjectopia isObjective) 
		ifTrue: [
			Subjectopia viewSystemComplexityMethod: (FAMIXClassGroup methodDictionary at: #viewSystemComplexity).
			FAMIXClassGroup methodDictionary removeKey: #viewSystemComplexity.
			Subjectopia viewDuplicationMethod: (FAMIXClassGroup methodDictionary at: #viewDuplicationComplexity).
			FAMIXClassGroup methodDictionary removeKey: #viewDuplicationComplexity.]! !

!Subjectopia methodsFor: 'restore methods' stamp: 'DanielLangone 2/10/2011 13:48'!
restoreDictionaryFrom: aDictionary to: aClass
	((aDictionary isNil not) and: [Subjectopia isSubjective])
		ifTrue: [
			aDictionary keysDo: [:key | 
				((aDictionary at: key) isNil) 
					ifTrue: [aClass methodDictionary removeKey: key] 
					ifFalse: [aClass methodDictionary at: key put: (aDictionary at: key)]]].
	^nil.! !

!Subjectopia methodsFor: 'restore methods' stamp: 'DanielLangone 2/10/2011 13:48'!
restoreFamixMethods
	(Subjectopia isSubjective) 
		ifTrue: [
			FAMIXClassGroup methodDictionary at: #viewSystemComplexity put: (Subjectopia viewSystemComplexityMethod).
			FAMIXClassGroup methodDictionary at: #viewDuplicationComplexity put: (Subjectopia viewDuplicationMethod).]! !

!Subjectopia methodsFor: 'initialize-release' stamp: 'DanielLangone 2/10/2011 13:49'!
start
"Convert Root Element of Moose Elements Hierarchy to Subject"
Subject subclass: #MooseElement
	instanceVariableNames: 'mooseID'
	classVariableNames: 'MooseID'
	poolDictionaries: ''
	category: 'Moose-Core'. 
(Subjectopia isSubjective) 
	ifTrue: [
		AlertDialogWindow new message: 'You are already in Subjective state'.]
	ifFalse: [
		"override and backup methods"
		Subjectopia temporaryMethodDictionaryMooseGroup: (self overrideDictionaryFrom: MooseGroup to: SubjectiveMooseGroup). 
		Subjectopia temporaryClassMethodDictionaryMooseGroup: (self overrideDictionaryFrom: (MooseGroup class) to: (SubjectiveMooseGroup class)). 
		
		Subjectopia temporaryMethodDictionaryObject: (self overrideDictionaryFrom: Object to: ObjectExtensions). 
		Subjectopia temporaryClassMethodDictionaryObject: (self overrideDictionaryFrom: (Object class) to: (ObjectExtensions class)). 

		Subjectopia temporaryMethodDictionaryMooseAbstractGroup: (self overrideDictionaryFrom: MooseAbstractGroup to: SubjectiveMooseAbstractGroup). 
		Subjectopia temporaryClassMethodDictionaryMooseAbstractGroup: (self overrideDictionaryFrom: (MooseAbstractGroup class) to: (SubjectiveMooseAbstractGroup class)). 

		self overrideFamixMethods.
		Subjectopia state: 1.]! !

!Subjectopia methodsFor: 'initialize-release' stamp: 'DanielLangone 2/10/2011 13:49'!
stop

Object subclass: #MooseElement
	instanceVariableNames: 'mooseID'
	classVariableNames: 'MooseID'
	poolDictionaries: ''
	category: 'Moose-Core'. "Reconvert Root Element of Moose Elements Hierarchy to Object"
(Subjectopia isObjective) 
	ifTrue: [
		AlertDialogWindow new message: 'You are already in Objective state'.]
	ifFalse: [
		"restore methods from backup"
		Subjectopia temporaryMethodDictionaryMooseGroup: (self restoreDictionaryFrom: (Subjectopia temporaryMethodDictionaryMooseGroup) to: (MooseGroup)). 
		Subjectopia temporaryClassMethodDictionaryMooseGroup: (self restoreDictionaryFrom: (Subjectopia temporaryClassMethodDictionaryMooseGroup) to: (MooseGroup class)). 
		
		Subjectopia temporaryMethodDictionaryMooseGroup: (self restoreDictionaryFrom: (Subjectopia temporaryMethodDictionaryObject) to: (Object)). 
		Subjectopia temporaryClassMethodDictionaryMooseGroup: (self restoreDictionaryFrom: (Subjectopia temporaryClassMethodDictionaryObject) to: (Object class)). 

		Subjectopia temporaryMethodDictionaryMooseAbstractGroup: (self restoreDictionaryFrom: (Subjectopia temporaryMethodDictionaryMooseAbstractGroup) to: (MooseAbstractGroup)). 
		Subjectopia temporaryClassMethodDictionaryMooseAbstractGroup: (self restoreDictionaryFrom: (Subjectopia temporaryClassMethodDictionaryMooseAbstractGroup) to: (MooseAbstractGroup class)). 

		self restoreFamixMethods.
		Subjectopia state: 0.]! !

Object subclass: #User
	instanceVariableNames: 'name password mailaddress device mailDeliverer room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Subjectopia-MailSending'!

User class
	instanceVariableNames: 'mailaddresses'!

User class
	instanceVariableNames: 'mailaddresses'!

!User class methodsFor: 'as yet unclassified' stamp: 'DanielLangone 9/11/2010 11:31'!
mailAddress: aMailAdress
	| temp |
	(mailaddresses isNil) ifTrue: [mailaddresses := Dictionary new].
	^((mailaddresses includesKey: aMailAdress) ifTrue: [mailaddresses at: aMailAdress] ifFalse: [temp := (self basicNew mailaddress: aMailAdress). mailaddresses at: aMailAdress put: temp. temp])! !

!User class methodsFor: 'as yet unclassified' stamp: 'DanielLangone 9/11/2010 11:19'!
new
	self error: 'Use mailAddress: instead of new.'.! !

!User methodsFor: 'comparing' stamp: 'DanielLangone 9/11/2010 11:20'!
= anotherUser
	^(self class = anotherUser class) and: [(self mailaddress = anotherUser mailaddress)]! !

!User methodsFor: 'accessing' stamp: 'DanielLangone 8/31/2010 13:55'!
device
	^device! !

!User methodsFor: 'setting' stamp: 'DanielLangone 8/31/2010 13:55'!
device:  aDevice
	device := aDevice! !

!User methodsFor: 'setting' stamp: 'DanielLangone 8/31/2010 14:01'!
mailDeliverer: aMailDeliverer
	mailDeliverer := aMailDeliverer.! !

!User methodsFor: 'accessing' stamp: 'DanielLangone 8/31/2010 11:26'!
mailaddress
	^mailaddress! !

!User methodsFor: 'setting' stamp: 'DanielLangone 8/31/2010 11:26'!
mailaddress: aString
	mailaddress := aString.! !

!User methodsFor: 'accessing' stamp: 'DanielLangone 8/31/2010 11:25'!
name
	^name! !

!User methodsFor: 'setting' stamp: 'DanielLangone 8/31/2010 11:25'!
name: aString
	name := aString.! !

!User methodsFor: 'print' stamp: 'DanielLangone 9/6/2010 16:40'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ': '; nextPutAll: self name; nextPutAll: ' '; nextPutAll: self mailaddress.! !

!User methodsFor: 'accessing' stamp: 'DanielLangone 9/4/2010 13:54'!
room
	^room! !

!User methodsFor: 'setting' stamp: 'DanielLangone 9/4/2010 13:54'!
room: aRoom
	room := aRoom! !

!User methodsFor: 'setting' stamp: 'DanielLangone 10/15/2010 16:14'!
sendMail: aMail
	^(mailDeliverer deliver: aMail withIdentity: (aMail recipient))! !

!User methodsFor: 'setting' stamp: 'DanielLangone 10/18/2010 10:06'!
sendMailPerspective: aMail
	| myPerspective |
	myPerspective := (mailDeliverer perspectivefor: self).
	^ (mailDeliverer deliverPerspective: aMail through: myPerspective)! !

!User methodsFor: 'setting' stamp: 'DanielLangone 10/18/2010 16:30'!
sendMailRole: aMail
	| myRole |
	myRole := (mailDeliverer rolefor: self).
	^ (mailDeliverer deliverRole: aMail through: myRole)! !
